2010-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : implement ToString().

2010-07-15  Atsushi Enomoto  <atsushi@ximian.com>

	* MtomMessageEncodingBindingElement.cs, MtomMessageEncoder.cs :
	  add missing members.

2010-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs, MessageEncoder.cs:
	  The default content type value is null, not the ContentType value.

2010-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : and move this too.

2010-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : split a couple of classes out.
	  Changed namespace to internal one.

2010-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelFactory.cs
	  SecurityChannelListener.cs
	  SecurityRequestContext.cs
	  SecurityOutputChannel.cs
	  SecurityReplyChannel.cs
	  SecurityRequestChannel.cs
	  SecureMessageGenerator.cs
	  SecureMessageDecryptor.cs
	  WSEncryptedXml.cs
	  WSSignedXml.cs
	  WSSecurityMessageHeader.cs :
	  moved to System.ServiceModel.Channels.Security.

2010-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityReplyChannel.cs : split from SecurityChannelListener.cs.
	* AsymmetricSecurityBindingElement.cs
	  WSSecurityMessageHeader.cs
	  SecureMessageDecryptor.cs
	  SecureMessageGenerator.cs
	  SecurityChannelListener.cs
	  SecurityRequestContext.cs
	  WSEncryptedXml.cs
	  SecurityRequestChannel.cs
	  SymmetricSecurityBindingElement.cs
	  SecurityOutputChannel.cs
	  SecurityChannelFactory.cs
	  WSSignedXml.cs
	  SecurityBindingElement.cs : change namespace to move to internal
	  namespace directory.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : remove extraneous buffering.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : avoid duplicate copy of headers into
	  the decrypted message.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs, MessageBufferImpl.cs, MessageImpl.cs: preserve and
	  output attributes prefixes, to copy Body/@wsu:Id to successfully
	  verify the xmldsig.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : MessageFault from Message could have empty
	  detail. Have it return HasDetail as expected.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestChannel.cs : do not try to decrypt faults, they
	  are not encrypted.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : to clone raw xml completely, avoid using 
	  ReadOuterXml() and text reader but use XmlNodeReader instaed.
	* Message.cs : avoid extraneous xmlns:u attribute.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs, MessageHeaderInfo.cs: add internal Prefix
	  property and copy them from source to destination.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : When XmlReaderMessage was writing its contents,
	  it was dropping body attributes, including wsu:Id for WS-Security.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : MessageBuffer was missing copy of
	  Body wsu:Id attribute.
	* HttpRequestChannel.cs : remove comment for resolved issue.

2010-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : move another old code.

2010-07-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : remove extra code.

2010-07-08  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlReaderBodyWriter.cs, MessageFault.cs: warning cleanups.

2010-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : null via uri parameter is not allowed.

2010-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportbindingElement.cs : remove "Standalone".

2010-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : removed old code and #if blocks.

2010-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : add required code for new ASP.NET HTTP stack.
	  Support for new and old stack (both) are temporarily enabled.
	* HttpTransportBindingElement.cs : switch to new ASP.NET stack.

2010-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs : remove unused code.
	* SvcHttpHandler.cs : ditto. Add some code for what new asp.net
	  support will look like.

2010-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs, MessageImpl.cs, MessageBufferImpl.cs : remove BodyId.
	  XML attributes on s:Body are handled appropriately, not limited to
	  wsu:Id. Added several required overrides to Message and
	  MessageBuffer implementation classes.
	* SecureMessageGenerator.cs : so, don't use BodyId. Treat it as a
	  specific case but still fallback.

2010-06-24  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs :
	  Use new HTTP channel listener implementation.

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : cosmetic code formatting fix.

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs :
	  No need to get messed around MetadataPublishingInfo anymore.

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : remove extra different code paths for
	  channel dispatchers with or without mex endpoints.

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : simplify FilterHttpContext().

2010-06-22  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : add some comments.

2010-06-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : use MessageVersion.None for GET messages.
	* HttpChannelListener.cs : remove extra field.
	* HttpListenerManager.cs : check HelpUrl existence (avoid NRE).
	* HttpRequestContext.cs : reduce internal field.

2010-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MtomMessageEncodingBindingElement.cs: it's base is abstract, use 
	  context.GetInnerProperty<T>().

2010-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : enable simpler MessageVersion code (issued got fixed).
	* MtomMessageEncodingBindingElement.cs, TransportBindingElement.cs,
	  TextMessageEncodingBindingElement.cs : return MessageVersion in
	  GetProperty<T>().

2010-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : add commented-out code for MessageVersion replacement.
	* TransactionFlowBindingElement.cs : implement (almost dummy).

2010-06-15  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpReplyChannel.cs : accept TCP channel on ReceiveRequest(). This
	  fixes standalone tcp-transport/sample[svc|cli]5.exe test in olive
	  (but not TcpTransportBindingElementTest.SimpleDuplexStreamed.)

2010-06-15  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpBinaryFrameManager.cs : lock read and write respectively.
	  Finally fixed bug #567672 ('IsOneWay=false' case).

2010-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* DirectionalAction.cs : remove old code from winfx beta.

2010-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs, TcpReplyChannel.cs : do not set RelatesTo
	  here. If the contract is not one-way (IsOneWay = false) and there is
	  a callback, the callback message sent to the client should *not* be
	  assigned RelatesTo header here. Just do it in the request-reply
	  context. Do it in OperationInvokerHandler.

2010-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : remove Sleep() hack. The host is now ensured
	  to wait for channels opened.

2010-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : remove unused field. Some code cleanup.

2010-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : use manual reset.
	* AspNetReplyChannel.cs : make it equivalent to the above.

2010-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : do not accept more than one channel at a
	  time. Remove extra fields. Add CancelAsync() implementation.

2010-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : add a workaround for Func<>.BeginInvoke()
	  problem that blocked ASP.NET channels working.

2010-05-19  Andreia Gaita  <avidigal@novell.com>

	* HttpRequestChannel.cs: if the response has no body, create an
	  empty message and return that.
	  Note: the ws-mc protocol defines that the service returns an
	  200 response with an empty body on first connection, this
	  adds support for that (fixes part of #599667)

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexChannelBase.cs
	  ReplyChannelBase.cs
	  TcpChannelListener.cs
	  ChannelListenerBase_1.cs
	  PeerChannelListener.cs
	  HttpChannelListener.cs
	  NamedPipeChannelListener.cs:
	  do the same for channel listener,reply channels and
	  duplex channels.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs, RequestChannelBase.cs : support
	  MessageVersion in GetProperty<T>() for many transport channels.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs
	  TcpChannelFactory.cs
	  ChannelFactoryBase.cs
	  NamedPipeChannelFactory.cs
	  PeerChannelFactory.cs
	  RequestChannelBase.cs : commonize MessageEncoder.
	  (Commented out GetPrpoerty<T>() for MessageVersion as it is 
	  in doubt yet.)

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : do not pass empty string array; it almost
	  always results in header-not-found error.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : do not try to lookup prefix for empty ns.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : do not use maxBufferSize for initialSize argument
	  for MessageHeaders. Fix OutOfMemoryException for certain usage.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingContext.cs : actually clone is needed everywhere else too.
	* CustomBinding.cs : remove extra field.

2010-05-14  Andreia Gaita  <avidigal@novell.com>

	* BindingContext.cs: Copy elements from the original binding only when
	creating it, never when cloning it. This way, CanBuildInnerChannel can
	work recursively as it should.

2010-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomBinding.cs : return clone collection.
	* BindingContext.cs :
	  Simply use RemainingBindingElements in builder methods.
	  Clone() should be deep copying (as documented).
	* BinaryMessageEncodingBindingElement.cs
	  MtomMessageEncodingBindingElement.cs
	  TextMessageEncodingBindingElement.cs
	  HttpCookieContainerBindingElement.cs :
	  do not add itself to RemainingBindingElements.
	* HttpChannelFactory.cs
	  HttpChannelListener.cs
	  TcpChannelFactory.cs
	  TcpChannelListener.cs
	  MsmqChannelFactory.cs
	  MsmqChannelListener.cs
	  NamedPipeChannelFactory.cs
	  NamedPipeChannelListener.cs
	  PeerChannelFactory.cs
	  PeerChannelListener.cs : do not iterate RemainingBindingElements.
	  Instead, iterate all binding elements in the CustomBinding.

2010-05-12  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : implement On[Begin|End][Close|Open] methods.

2010-04-30  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : use manual reset here to not cause
	  possible inconsistent locking.

2010-04-28  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs, HttpListenerManager.cs :
	  Fix NRE issue in olive/samples/wcf/web-http-binding/samplesvc3.exe.

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : fixed the issue that mex_info is never
	  retrieved from the latest channel listener (which could be other
	  listener than the one which was set mex info).

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs, HttpListenerManager.cs :
	  actually it should be ChannelDispatcher-to-HttpChannelListener,
	  to identify which dispatcher to send reqs.

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : remove old Http Keep-Alive workaround.

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs,
	  HttpChannelListener.cs,
	  HttpListenerManager.cs : add host-to-http-listener mapping so that
	  they can be managed per host.

2010-04-21  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingContext.cs : require a TransportBindingElement when
	  building a channel listener.

2010-04-19  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : use local var to hold wait handle to avoid
	  possible NRE on field. Based on the patch by Matt Dargavel.

2010-04-07  Miguel de Icaza  <miguel@novell.com>

	*  BufferManager.cs: Implement the BufferManager. 

2010-04-07  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : add FIXME comment.

2010-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : add commented note.

2010-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : fill To header only if it does not exist.

2010-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : set ReplyTo and To, do not add.

2010-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : use matching addressing version.
	  Remove header item if the same ones already exist.

2010-04-06 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* HttpRequestChannel.cs: don't create the wait handle unless it is
	really needed.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : use correct max buffer size.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : check null serializer and detail.
	  Make sure to consume s12:Reason EndElement.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : when created from XmlReader, it should not
	  deserialize fault details immediately. This class itself should
	  not do that. Strongly typed FaultContractInfo may want to use the
	  reader (GetReaderAtDetailContents()) for its own deserialization.

2010-04-01  Atsushi Enomoto  <atsushi@ximian.com>

	* ConnectionOrientedTransportBindingElement.cs,
	  TcpTransportBindingElement.cs : implement GetProperty<T>().

2010-04-01  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs, HttpsTransportBindingElement.cs:
	  implement HttpsTransportBindingElement.GetProperty<T>(). Extend the
	  properties type from HTTP.

2010-04-01  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : use addressing version from the message.

2010-03-30  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : check envelope version, not addressing version.

2010-03-29  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : implemented TryCreateException().

2010-03-29  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : cosmetic method name clarification.

2010-03-29  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlReaderBodyWriter.cs, Message.cs, MessageImpl.cs, BodyWriter.cs:
	  fix BodyWriter buffering that dropped in-scope namespaces and thus
	  caused problem on resolving QNames.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : do implement OnTryCreateFaultMessage() to work
	  with certain Exception types.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : fix explanation on CreateMessage() overloads.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : Write Subcode element correctly and fix wrong
	  Code/Value/Subcode element relationship. Give better error message.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : ok, no need for conditional code path.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* AddressingVersion.cs : add fault action namespace.

2010-03-26  Sebastien Pouliot  <sebastien@ximian.com>

	* HttpRequestChannel.cs: There is no WebHeaderCollection.Add 
	method in SL API

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : pass IsFault argument in OnCreateBufferedCopy().

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContext.cs, AspNetRequestContext.cs : return HTTP 500
	  for fault message.

2010-03-26  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : create HttpResponseMessageProperty.

2010-03-25  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContext.cs : removed HTTP status rewriting for
	  commented reason.

2010-03-25  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : handle only 4xx errors as to not process
	  content stream.

2010-03-25  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : do not use SOAP11 namespace for fault contents.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs, HttpReplyChannel.cs : add some locking.
	  Patch by Matt Dargavel.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : use lock object which is subject to
	  change. Fix by Matt Dargavel.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : remove consumed HttpListenerContext from
	  the pending queue. Compare "wsdl" request in case insensitive
	  manner. Patch by Matt Dargavel.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContext.cs : apply the patch by Matt Dargavel, which is
	  supposed to provide detailed 400 error message.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* TransactionFlowBindingElement.cs: revamp the previous change to
	  not regress regarding service metadata.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelListenerBase.cs, TransactionFlowBindingElement.cs: fix 
	  GetProperty<T>() bug that fails to retrieve properties. (This may
	  be rewritten later if an ongoing change proposal is to take place.)

2010-03-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ReliableSessionBindingElement.cs,
	  PrivacyNoticeBindingElement.cs,
	  RemoteEndpointMessageProperty.cs : added some missing types.

2010-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs :
	  why does it filter out most of the headers? kill it.

2010-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs, AspNetReplyChannel.cs, HttpChannelListener.cs,
	  HttpListenerManager.cs : refactoring on acquiring SvcHttpHandler
	  to not raise "not found" error (see bug #573795).

2010-03-16  Jb Evain  <jbevain@novell.com>

	* HttpRequestChannel.cs, HttpTransportBindingElement.cs: use
	MOONLIGHT symbol to disambiguate MonoTouch and Moonlight code.

2010-03-09  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : For ASP.NET, use correct GenericIdentity
	  type, and use null password unless we find a chance to get password
	  in ASP.NET HttpContext.

2010-03-03  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, AspNetReplyChannel.cs, HttpChannelListener.cs,
	  HttpListenerManager.cs : ongoing authentication support. It returns
	  401 as expected, but somehow fails to retrieve user info.

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : this change (along with HttpListener
	  implementation) somehow fixes basic auth. connection error...

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : add !NET_2_1.

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs, MessageHeaders.cs : add nasty workaround for
	  typed UniqueId output.

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : no need to treat EndpointAddress as a special
	  case here too.

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : remove duplicate constant.

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs, MessageHeaders.cs: MessageHeader does not treat
	  EndpointAddress as a special case. Instead, each MessageHeaders
	  property should convert it to appropriate serializable objects.

	  (Our DataContractSerializer fails to reject EndpointAddress as
	  serializable type, so it's rather a preparation step.)

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs, Message.cs : use dictionary string whenever
	  applicable. The binary output on #577139 is getting closer (no
	  idea if it is really about binary output though).

2010-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : moved soap_dictionary to Constants.

2010-02-05  Atsushi Enomoto  <atsushi@ximian.com>

	*  HttpTransportBindingElement.cs : ... and add MONOTOUCH on #ifs.

2010-02-05  Atsushi Enomoto  <atsushi@ximian.com>

	*  HttpRequestChannel.cs, HttpTransportBindingElement.cs :
	  enable authentication schemes on monotouch.

2010-02-04  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : a wait handle could be used for more than one
	  requests and hence it sometimes blocked one reply channel. Now
	  it creates a wait handle for each ASP.NET request so that such
	  multiple use should not occur. This should fix blocking on
	  concurrent requests (it indeed fixes as long as I can see).

2010-02-04  Atsushi Enomoto  <atsushi@ximian.com>

	* AspNetReplyChannel.cs : remove garbage output.

2010-02-04  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : Use lock when it tries to create the service
	  host.

2010-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs : lock when it tries to acquire
	  HttpHandler.

2010-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : add another workaround for blocking
	  concurrent calls.

2010-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : small refactoring.

2010-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : added a workaround receiver delay
	  that somehow makes callback client to not cause infinite loop.

2010-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs, PeerDuplexChannel.cs,
	  DuplexChannelBase.cs : Receive() should rather use TryReceive().
	  It should not be in reverse order.

2010-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, HttpListenerManager.cs :
	  Implement async cancellation in the expected manner (though with
	  some hack). This mostly removed nunit blockers.

2010-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : fix wrong status changes.

2010-01-20  Atsushi Enomoto  <atsushi@ximian.com>

	* AddressHeader.cs : XmlSchema.InstanceNamespace didn't exist in 2.1 :(

2010-01-20  Atsushi Enomoto  <atsushi@ximian.com>

	* AddressHeader.cs : implement remaining bits.
	  Eliminate dependency on NetDataContractSerializer.

2010-01-20  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : in Fault(), do similar work as previous
	  change does.

2010-01-19  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : when process state changes, lock the
	  object to make sure the state transition is valid.
	  Change OnClosed/OnClosing to do the way OnOpened/OnOpening does.

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : implement SetAction().

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : fix build.

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBase.cs : cosmetic API fix for SL3.

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs :
	  implement On{Begin/End}Close() on the generic type.

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs, TcpChannelFactory.cs,
	  ChannelFactoryBase.cs, NamedPipeChannelFactory.cs
	  PeerChannelFactory.cs, HttpRequestChannel.cs:
	  fix ChannelFactoryBase API; move On(Begin/End)Open() to internal
	  type and made required changes.

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpCookieContainerBindingElement.cs : new.
	* IHttpCookieContainer.cs : fix type name.
	* HttpRequestChannel.cs, HttpChannelFactory.cs : support above.

2010-01-07  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpBinaryFrameManager.cs : treat EOF as interrupted stream too (it
	  does not happen when communicating with .NET client but happens with
	  mono). Seealso FIXME comment.
	* TcpDuplexSessionChannel.cs : do not try to close session when it
	  failed to read sized message. The connection is already dead.

	  Fixed bug #567949.

2010-01-07  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs :
	  Write EndRecord only when the connection is available.
	  Remove hack - do let ChannelDispatcher close the channel.
	* TcpBinaryFrameManager.cs :
	  The socket may be disconnected when trying to read a sized message,
	  so check some socket exceptions.
	  In case the client silently shuts down without EndRecord and
	  reconnects to the server with preamble while expecting a sized
	  message (which is so lame, but that's what .NET often does), refresh
	  preamble and continue.

	  This fixes some cases of bug #567949 but not all.

2010-01-06  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : enable workaround buffering only when
	  the argument stream does *not* support seek. This fixes some
	  net.tcp connection problem.

2009-12-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpBinaryFrameManager.cs : If preamble byte is not available from
	  the client stream, detect it to close the reply or input channel.
	* TcpRequestChannel.cs : send preamble at each request time.
	  It differentiates communication behavior on such cases that involve
	  single open and multiple requests.
	* TcpReplyChannel.cs : close the channel only when the channel is
	  oeprated to close i.e. do not close the socket every time.
	  Process preambles on each request (the same as request channel).

2009-12-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpBinaryFrameManager.cs : unsized envelope record may have more
	  than one data block, so consume them accordingly. This should fix
	  large buffer consumption.

2009-12-21  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : support EnvelopeVersion.None as well, as almost
	  the same as SOAP12.

2009-12-17  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContext.cs : for DestinationUnreachable message, this
	  channel returns 400 in .NET.

2009-12-16  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : added workaround for strange stream
	  consumption error raised by HttpTransport + Binary encoder example.
	* BinaryMessageEncodingBindingElement.cs:
	  only SOAP 1.2 is allowed for this encoder.

2009-12-14  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlReaderBodyWriter.cs : don't try to write empty xml.

2009-12-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : avoid adding duplicate headers. Basically
	  default WebHeaderCollection items are overwritten.

2009-12-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : when HTTP response was error, do not try
	  to read message but just raise an error.

2009-12-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : null can be set as a WS-Addressing header item.

2009-12-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : WebException.Response might be null.

2009-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs : added listener property.
	* SecurityChannelListener.cs : quick async impl, as ServiceHost has
	  been updated to prefer async by default, a while ago.

2009-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs : finished all GetProperty() values.

2009-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : disabled carelessly added
	  "UseDefaultCredentials = false" line. It blocked basic auth.

2009-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs, HttpChannelFactory.cs,
	  HttpChannelListener.cs, HttpListenerManager.cs :
	  implemented http client authentication and some of corresponding
	  service code. Only client works so far.

2009-12-03  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpsTransportBindingElement.cs, HttpChannelListener.cs :
	  added URI scheme check.

2009-12-03  Atsushi Enomoto  <atsushi@ximian.com>

	* TransportSecurityBindingElement.cs : fix 2.1 build.

2009-12-03  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpsTransportBindingElement.cs :
	  RequireClientCertificate is false by default.
	  Remove extra #if NET_2_1.
	* SecurityBindingElement.cs :
	  Implement some transport security factory methods.
	* TransportSecurityBindingElement.cs :
	  It is not ISecurityCapabilities anymore.

2009-11-25  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs
	  SecurityBindingElement.cs
	  LocalClientSecuritySettings.cs
	  TransportSecurityBindingElement.cs
	  FaultConverter.cs : They are now part of SL3 API.

2009-11-17  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncodingBindingElement.cs : changes for 2.1 build.

2009-11-05  Geoff Norton  <gnorton@novell.com>

	* HttpsTransportBindingElement.cs: Implement basic https transport
	binding support for Moonlight and MonoTouch

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : remove CWLs.

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : move back previous listener selector code in
	  ProcessRequest(). Unlike HttpListener, ASP.NET does not refine
	  and differentiate requests to deeper paths (such as /jsdebug), so
	  we need such refinement here.

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : dependent fix to ServiceMetadataExtension
	  changes.

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs, HttpReplyChannel.cs, AspNetReplyChannel.cs,
	  HttpChannelListener.cs, HttpListenerManager.cs :
	  Similar refactoring on ASP.NET side to the previous one.
	  Added ASP.NET implementation of HttpListenerManager and use some
	  part of it in SvcHttpHandler (ASP.NET stack does not fully make use
	  of the manager yet).
	  Rewrote AspNetReplyChannel to become almost the same as
	  HttpSimpleReplyChannel, to hopefully unify them later.
	  Now it dispatches requests to *.svc for wsdl, help and SOAP as long
	  as ServiceThrottle has MaxConcurrentSessions=1. Also REST calls
	  are still broken.

2009-10-20  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, HttpChannelListener.cs, HttpListenerManager.cs:
	  Refactoring on listener manager to correctly handle wsdl and help
	  requests for such case that they conflict in addressing. Now it
	  can correctly distinguish service calls, WSDL requests and help
	  requests when all of them point to "http://localhost/foo.svc"
	  (which is very common case that the user does not change Http*Url).

2009-10-16  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelListenerBase.cs : add Properties property to add arbitrary
	  properties handy (only inside this assembly).

2009-10-16  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : fix warning.

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, AspNetReplyChannel.cs : set Via property.

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : make sure to release wait lock.
	* HttpChannelListener.cs : session channels are not supported, so
	  remove relevant NIEs.

2009-10-15  Sebastien Pouliot  <sebastien@ximian.com>

	* HttpRequestChannel.cs (WaitEnd): Neither Moonlight nor MonoTouch
	support contexts so we call the non-overloaded WaitOne method 
	(which defaults to false).

2009-10-13  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs, AspNetReplyChannel.cs, HttpChannelListener.cs:
	  significant rewrite to cooperate wcf handler and asp.net handler
	  to not mix multiple WCF listener within the asp.net handler.
	  So far it mostly works when 1) there are no ChannelDispatchers
	  that have an identical listen Uri and 2) MaxConcurrentSessions is
	  1 (must be explicitly set).

2009-10-13  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : give better state error description.

2009-10-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : OnOpening() and OnOpened() require calls
	  to base methods. This resulted in not a few changes everywhere.

2009-10-07  Atsushi Enomoto  <atsushi@ximian.com>

	* IHttpCookieContainer.cs : new 2.1-only interface (no use).

2009-10-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : use file path given by the factory to
	  construct BaseAddresses. Requests to "test.svc/jsdebug" should
	  not be handled as request to "jsdebug" file, it's rather an
	  "argument" to "test.svc".

2009-10-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs, HttpChannelListener.cs : some significant
	  rewrite to handle shutdown situation better. The listeners should
	  not close channels that it opened. Instead, just stop accepting
	  further requests. Removed blocking mutex on WaitForRequest().
	  Now xsp shuts down as expected.

2009-10-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : lock list when releasing its content contexts.
	* AspNetReplyChannel.cs : send EndRequest() to handler when it is
	  closing.

2009-10-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs : remove todo.
	* ReplyChannelBase.cs : add comment.

2009-10-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs, SvcHttpHandlerFactory.cs :
	  revert the change, to use internal asp.net state again.
	* SvcHttpHandler.cs : add VirtualPathExtension.

2009-10-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, AspNetReplyChannel.cs, AspNetRequestContext.cs:
	  asp.net response was not written correctly.
	  Fill HttpRequestMessageProperty to get handle WSDL requests
	  processed in ServiceMetadataExtension without NRE.
	  Remove wrong HttpListenerContext iteration at Abort and Close in
	  common base class and move it to non-asp derived channel.

2009-10-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : remove unused code.

2009-09-30  Jb Evain  <jbevain@novell.com>

	* HttpRequestChannel.cs: When compiling for MonoTouch, avoid
	to use any of the remoting features.

2009-09-30  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs, HttpTransportBindingElement.cs :
	  use AspNetCompatibilityEnabled.
	* SvcHttpHandler.cs : disable ApplyConfiguration(). It should be done
	  at ServiceHostBase.
	* AspNetReplyChannel.cs : remove extra field.

2009-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : remove extra field.

2009-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* AspNetRequestContext.cs : remove CWL.

2009-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* AspNetReplyChannel.cs, AspNetRequestContext.cs : close HttpContext
	  only after AspNetRequestContext is closed. Do not close it
	  immediately after receiving the context. (HttpRuntime destructs it
	  and further uses then becomes impossible.)

2009-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* AspNetReplyChannel.cs, HttpReplyChannel.cs : add some comments.
	* SvcHttpHandlerFactory.cs, SvcHttpHandler.cs, HttpChannelListener.cs:
	  Make sure that AspNetChannelListener is bound to correct
	  SvcHttpHandler, regardless of specific request URI. It is required
	  for both WSDL requests and RESTful binding requests.

2009-09-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageProperties.cs : fix CopyProperties() behavior to not
	  clear existing items. Make all properties call this[name].

2009-09-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs : fix 2.1 build.

2009-09-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TransportBindingElement.cs : another GetProperty fix, iterate
	  other binding elements.

2009-09-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs, PeerTransportBindingElement.cs :
	  some GetProperty() implementation.

2009-09-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : release HttpListener and avoid extra
	  close process more than once.

2009-09-11  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : do not iterate channel list to close
	  channels which in turn removes them from the list while iteration.

2009-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : Fix message version member comparison.
	  Double-quote SOAPAction. Remove extra Exception.
	* HttpReplyChannel.cs : ditto for version comparison. Unquote above.
	* HttpRequestContext.cs : when addressing is None, remove action
	  from the message.

2009-09-04  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : set Uri property based on baseAddresses and
	  path, to pick those endpoints that are added at custom factories.

2009-09-03  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : apply configuration, and if there is still no
	  endpoint, then add default one.

2009-09-03  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : another URL to make relative.

2009-09-03  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs : some GetHandler changes.
	* SvcHttpHandler.cs : significant changes on receiver structure. Now
	  ProcessRequest() stores pending requests (this might be extraneous,
	  but maybe useful when it implements async handler). Also removed
	  reply_channel field as it may become to handle multiple requests.
	* HttpChannelListener.cs : bind to corresponding SvcHttpHandler.
	* AspNetReplyChannel.cs : make it receive requests like
	  HttpReplyChannel (for HttpListener) to make them consistent.

2009-09-03  Atsushi Enomoto  <atsushi@ximian.com>

	* AspNetRequestContext.cs, HttpRequestContext.cs :
	  fix NRE on HttpListenerContext for AspNetRequestContext (mismatch)
	  by splitting HttpListener-based context out from common code base.

2009-09-03  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : use baseAddresses in ServiceHost and make URIs
	  relative or absolute. new Uri ("/foobar") doesn't work on non-unix
	  environment.

2009-09-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandlerFactory.cs : make use of BuildManager aid. Now it
	  loads types from system assemblies appropriately.

2009-09-02  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlReaderBodyWriter.cs : implement OnCreateBufferedCopy()
	  for XmlReader input.

2009-09-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestMessageProperty.cs : fix default values.

2009-08-31  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs, HttpRequestChannel.cs,
	  ChannelFactoryBase.cs : fix to previous one; allow null Via uri.
	  Check ManualAddressing value and reject address-missing ones.

2009-08-31  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs : reject URI mismatch cases when required.

2009-08-26  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : When received Connect() from neighbor,
	  add the peer to its internal list.
	  Finally ChatApplication got working.

2009-08-26  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : since the channel factory is per instance,
	  do not reuse factory that is tied to different callback instance.
	  It resolved the issue that mono callback client didn't receive
	  messages from the client itself.

2009-08-26  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : in the Welcome response, return the NodeId
	  of the receiver, not the requestor. It resolved the issue that
	  .NET client didn't send further messages to mono server.

2009-08-26  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : remove some comment on [MC-PRCH] behavior.
	* TcpDuplexSessionChannel.cs, TcpBinaryFrameManager.cs,
	  TcpReplyChannel.cs, TcpRequestChannel.cs,
	  NamedPipeReplyChannel.cs, NamedPipeRequestChannel.cs:
	  rename EndRecord handling method to appropriate one.
	  Write EndRecord from recipient too.

2009-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : add PeerFlooder header (see comment).
	  Process PeerTo header to upgrade Message To header. Now mono
	  service accepts mono client (somehow not true for .NET client).

2009-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs, TcpRequestChannel.cs,
	  NamedPipeRequestChannel.cs : no need to add ReplyTo headers.

2009-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : fix PeerTo/PeerVia header namespace.

2009-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : check channel state before processing
	  Send and Receive.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* NamedPipeReplyChannel.cs, NamedPipeRequestChannel.cs,
	  NamedPipeChannelFactory.cs, NamedPipeChannelListener.cs :
	  ongoing works, not working at all yet.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpReplyChannel.cs :
	  cosmetic cleanup and corrections.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelFactory.cs : use expected Via uri.
	  Remove extra NIE stuff that are implemented in base.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : remove extra code.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : ongoing implementation towards get callback
	  replies on peer connector clients (not working as duplex client
	  callback is not working yet).

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : in callback client channels,
	  OperationContext.IncomingMessageHeaders is null.

2009-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : duplicate check was sloppy.

2009-08-18  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs, MessageImpl.cs, BodyWriter.cs :
	  Implement BodyWriter.OnCreateBufferedCopy() and use it.

2009-08-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs : initialize field.

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs, DuplexChannelBase.cs, RequestChannelBase.cs:
	  implement GetProperty<T>() and return its channel manager.

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : ongoing implementation. Fix wrong peer
	  destination address in Connect() request. To repeat sending
	  request, use buffered copy. Set some peer-channel specific
	  header items. (todo: and consume them.)

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : state is set only after WriteBodyContents().

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : eliminate wrong use of
	  ReadElementContentAsString() (it is not always simple string).

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : when the value is null, do not try to
	  deserialize EndpointAddress.

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	 * MessageHeader.cs : add Value property. (Forgot dependent change.)

2009-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	 * MessageHeaders.cs : GetHeader<T>() could mostly skip extra
	   serialization and deserialization of values.

2009-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : handle Welcome and Refuse at client side.
	  Now simply use connector contract.

2009-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : handle Disconnect(). Fix URLs a bit.

2009-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs : do not try to compare dead connection's
	  IPEndPoint (it raises an error).

2009-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : allow null header value on each specific setter.

2009-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexChannelBase.cs, TcpDuplexSessionChannel.cs :
	  get local and remote address of connected counterpart to get
	  callback channel connected.
	* PeerDuplexChannel.cs : remove FIXME wrt above.

2009-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : add fixme comment and remove extra FIXME.

2009-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : fill IsReferenceParameter.

2009-08-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs, TcpReplyChannel.cs, HttpReplyChannel.cs:
	  implement remaining async methods and LocalAddress.

2009-08-05  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : ongoing listener refactoring. Now it uses
	  ServiceHost to process neighbor connection (not sure if this is
	  right way to go though ...).

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : ongoing [MC-PRCH] implementation. Rewrote
	  connection part to use new internal IPeerConnectorContract for
	  neighbor connection.

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelListenerBase_1.cs, TcpChannelListener.cs,
	  PeerChannelListener.cs, HttpChannelListener.cs :
	  support ListenUri accordingly too so that it could be used when
	  it is different from LocalAddress.Uri.

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelFactory.cs, TcpDuplexSessionChannel.cs,
	  TcpRequestChannel.cs : use Via uri to validate and connect.

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* RequestChannelBase.cs, DuplexChannelBase.cs :
	  Return endpoint address Uri when no explicit Via uri is specified.
	* ChannelFactoryBase.cs : Remove extra async close methods.
	  Add async open methods. Reject null EndpointAddress.
	* PeerChannelFactory.cs : remove async open methods (now in base).

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : set correct message endpoint (To header).

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs, PeerDuplexChannel.cs,
	  DuplexChannelBase.cs : set LocalAddress property at base.

2009-07-30  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : ongoing refactoring to work both as
	  listener and client. Now it creates a listening peer node, and
	  creates a set of TCP client channels for each peer in the mesh.

	  (EndpointAddress must be fixed to not filter out correct inputs).

2009-07-30  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerChannelListener.cs : do not accept more than one channel
	  which results in lots of listening peer node. Only one is enough.

2009-07-30  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexChannelBase.cs : fix wrong loop implementation.

2009-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs : to avoid creating two or more channels
	  for one remote endpoint, check existing remote endpoints and
	  ignore such connections (it must be handled in different thread
	  fired by ChannelDispatcher loop).

2009-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpReplyChannel.cs : make sure to not try to receive request when
	  it is already closed.

2009-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpDuplexSessionChannel.cs :
	  some mannerless clients [*1] do not send EndRecord accordingly, but
	  such channels at listener side should not be kept open. So, close
	  disconnected channels when the listener needs to accept another
	  one.
	  [*1] see olive/samples/wcf/clientbase/samplecli4.cs.

2009-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs :
	  Remove extra NIE overrides.
	  Implement OnAbort() apart from OnClose().
	  For duplex session channel, unlike reply channel, it must acquire
	  TCP connection before OnOpen(), otherwise ChannelDispatcher
	  releases the connection acceptance WaitHandle and the detected
	  live connection may be stolen by another channel acceptor.

2009-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : implement OnAbort().

2009-07-24  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerChannelListener.cs : set source field. Remove unnecessary NIE.
	* DuplexChannelBase.cs : comment out some extra fields (so far).
	* PeerDuplexChannel.cs : pass valid EndpointAddress to PeerNodeImpl.

2009-07-24  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerCustomResolverBindingElement.cs : add some null checks.

2009-07-23  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpReplyChannel.cs, TcpRequestChannel.cs:
	  Acquire TcpClient for each request/reply. Now it is fully
	  interoperable with .NET.

2009-07-23  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpReplyChannel.cs, TcpRequestChannel.cs: it somehow adds/expects
	  ReplyTo and MessageId (though it is session-less), and it expects
	  EndRecord at weird stage, inconsistent with [MC-NMF]...
	  Now .NET service accepts one mono client request.

2009-07-23  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpReplyChannel.cs, TcpRequestChannel.cs, TcpBinaryFrameManager.cs:
	  Send and receive unsized message terminator at once.
	  Send EndRecord mutually. Got one .net client request working.

2009-07-23  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : revert the previous dictionary change.
	  They are indeed used for non-in-band-dictionary messages.

2009-07-23  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs, TcpBinaryFrameManager.cs:
	  split out binary frame manager class into separate file.

2009-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpReplyChannel.cs : new reply channel implementation.
	* TcpChannelListener.cs : use above for streamed reply channel.
	* TcpDuplexSessionChannel.cs : more streaming mode support.
	* TcpRequestChannel.cs : a couple of updates to get it working
	  with the reply channel above. Still some issues on .NET interop.

2009-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* RequestContext.cs : added internal derived class that implements
	  some members.

2009-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : for non-session reader and writer, do not
	  use dictionary.

2009-07-17  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs: add the registered node itself to peer list.
	  (The messaging must be done as TCP request/reply pattern, so it's
	  not working yet.)

2009-07-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpRequestChannel.cs : new channel file (TCP for request/reply
	  messaging pattern). The messaging part is not working yet.
	* TcpChannelFactory.cs : support IRequestChannel.
	* TcpDuplexSessionChannel.cs : add unsized message support.

2009-07-17  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs, RequestChannelBase.cs :
	  A couple of async members are now implemented in the base class.
	  Ditto for EndpointAddress and Via.

2009-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : now it implements some of node management
	  functionality and Send operation. The receiver part is not yet.

2009-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpDuplexSessionChannel.cs : do not pass
	  timeout to channel constructor. it does not make sense.

2009-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerChannelFactory.cs, PeerChannelListener.cs : add MessageEncoder
	  as common interface member, and use binary encoder (not text).

2009-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs : PeerNode constructor argument changes.

2009-07-08  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs, PeerChannelListener.cs, PeerOutputChannel.cs,
	  PeerInputChannel.cs, PeerChannelFactory.cs : those channels are
	  going to be unified to PeerDuplexChannel. And it is likely that
	  input and output functionalities are to be unified too.

2009-07-08  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelFactory.cs : (TcpChannelInfo) ease type restriction. I
	  may have to reuse it for peer transport.
	* PeerChannelListener.cs : add binding member.
	* PeerDuplexChannel.cs : remove NIE overrides. Fill fields a bit.

2009-07-08  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs, HttpChannelFactory.cs,
	  PeerChannelFactory.cs : close opened channels at OnClose() as
	  documented. Implement async methods.
	* PeerChannelListener.cs : removed some NIE overrides.

2009-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexChannelBase.cs : some more async methods.

2009-06-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : on Abort(), do just Close() within
	  (almost) no time.
	* TcpChannelListener.cs : accept multiple channels at a time.

2009-06-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : do not output all (stored) writer
	  session strings but output only those new ones in current message.
	  This fixes inconsistent body output in repetitive use of sender.

2009-06-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : handle EndRecord for repetitive
	  operation that does not involve session.
	  Preserve writer session as well as reader session.
	* MessageHeaders.cs : take name and namespace into consideration
	  when creating a serializer.

2009-06-25  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpDuplexSessionChannel.cs :
	  Made required changes for repeated use of message exchanges.
	  Hold binary reader session. The channels use it incrementally.
	  Preambles are handled at Open, and EndRecords are handled at
	  Close, Add session shutdown hook here (not working yet though).

2009-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelListenerBase_1.cs : added cancellation hook here too.
	  HttpChannelListener.cs : use above.
	  Do not allow parallel channel creation (this listener does not
	  allow more than one AcceptChannel().

2009-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs, HttpReplyChannel.cs :
	  Add cancellation hook for async TryReceiveRequest.

2009-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs, HttpListenerManager.cs :
	  slightly improved BuildChannelListener().
	  Implement OnAbort() and differentiate it from OnClose().

2009-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : remove NIE stubs.

2009-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexChannelBase.cs : simple async delegate calls here too.

2009-06-16  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs : cosmetic dependency reduction on listener.

2009-06-16  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : cosometic simplification.

2009-06-16  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : Fixed timeout handling. It was causing
	  infinite block in 2.0 profile.

2009-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpDuplexSessionChannel.cs :
	  more careful close to avoid NRE.

2009-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : do not Close() more than once (though
	  it is allowed to call it twice, we don't reject it; just ignore).

2009-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomBinding.cs : copy timeouts from argument binding in copy ctr.

2009-06-11  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : reject multiple WaitForRequest calls.
	  Temporarily disable HTTP Keep-Alive since it somehow results in
	  wrong reuse of connection (shown as NRE in HttpConnection).
	  Make sure to close RequestContext which was created from it.
	* HttpRequestContext.cs : simplify.

2009-06-11  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs, TcpChannelListener.cs,
	  ChannelListenerBase_1.cs : put common internal listener base
	  and let it handle those async stuff.

2009-06-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs : fix wrong null delegate check point.

2009-06-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs, ReplyChannelBase.cs : async operations are
	  now implemented as virtual in base class. Remove NIEs in http.

2009-06-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : hack async implementation.

2009-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerManager.cs : oops, extra line removal.

2009-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelManager.cs, HttpListenerManager.cs : rename file too.

2009-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelManager.cs, HttpChannelListener.cs: renaming, as
	  "ChannelManager" is confusing (there is ChannelManagerBase).

2009-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelManager.cs, HttpTransportBindingElement.cs,
	  HttpReplyChannel.cs, AspNetReplyChannel.cs, HttpChannelListener.cs:
	  they should be split into separate listener->reply channel lines
	  (remove "if (HostingEnvironment.IsAspNet)".)

2009-06-08  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : OnClosed() requires call to base method.
	  Close() could rather abort the channel, and Abort() does not
	  always invke OnAbort().
	* ChannelBase.cs : add call to base as above.

2009-06-05  Sebastien Pouliot  <sebastien@ximian.com>

	* ClientAccessPolicy.cs: Removed
	* CrossDomainAccessManager.cs: Removed
	* CrossDomainPolicy.cs: Removed
	* HttpRequestChannel.cs: Remove call to CrossDomainAccessManager 
	since this is now done inside the BeginGetResponse call (outside
	this assembly) for Moonlight (NET_2_1)

2009-06-04  Alan McGovern  <amcgovern@novell.com>

	* HttpRequestChannel.cs : Rewrite ProcessRequest to use the async APIs
	instead of the sync apis. Prevents a possible deadlock condition in
	moonlight. 

2009-06-03  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : that SL2/ML2 does not seem to allow null
	  callbacks, so add hacky ones.

2009-06-01  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : WaitForMessage() should not return
	  true when socket input is not available.

2009-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : Moved tcp listener accept to OnOpen().
	  I cannot precisely identify when EndRecord should be consumed,
	  so allow it at either at the end of ReadSizedMessage() or on
	  consuming preamble (it's likely handling EndRecord of previous
	  message though).

	  Now duplex IPeerResolverContract communication works between
	  either of .NET/Mono client and .NET/Mono server.

2009-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : looks like I have added some bogus
	  code. Handle preamble ack on ReadSizedMessage() only at server.
	  Consume EndRecord from server, at client side. Though it is likely
	  changed as it's blocking when mono is at server side.

2009-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : .NET seems to be based on somewhat
	  different protocol than existing code with related to preamble ack.
	  So changed it to work fine with .NET client (finally).

2009-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageBufferImpl.cs : do not output Action twice.

2009-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageBufferImpl.cs : it did not copy headers.
	* Message.cs : remove 2_1 conditional implementation for buffered
	  copy and hence remove bogus code.

2009-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageProperties.cs : copy argument is wrong.

2009-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerCustomResolverBindingElement.cs : some argument check.

2009-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : the serializer somehow leaves binary
	  xml open, so close the writer as well as open elements.
	* TcpDuplexSessionChannel.cs : clear write buffer on each operation.
	  Do not output EndRecord and SizedMessage at a time.

2009-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : there was a miscalculation on the
	  length of the SizedMessage in the output.

2009-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : use sane default timeout.
	* PeerCustomResolverBindingElement.cs : check timeout arg sanity.
	* TcpDuplexSessionChannel.cs : ditto.

2009-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : It seems that buffered stream channel
	  only accepts buffered messages, so do as such for write buffers.
	  Add RelatesTo header.

2009-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexSessionChannelBase.cs, DuplexChannelBase.cs:
	  rename from former to latter.

2009-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : reader does not always return full
	  buffer (depending on the stream).

2009-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs, PeerOutputChannel.cs : use new PeerNode.ctor.

2009-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerCustomResolverBindingElement.cs : (Resolve) returned addresses
	  could be null.

2009-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelManagerBase.cs : there was annoying non-2.1 stuff.

2009-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelListener.cs, TcpChannelFactory.cs : get reader quotas.

2009-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelManagerBase.cs : fix wrong session channel detection.

2009-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoderFactory.cs, BinaryMessageEncoder.cs
	  This encoder factory implements CreateSessionEncoder() and binary
	  encoder does support session transmit, in different media type.
	* ChannelManagerBase.cs : added utility method to create appropriate
	  encoder.
	* HttpChannelFactory.cs, HttpChannelListener.cs,
	  MsmqChannelFactory.cs, MsmqChannelListener.cs,
	  PeerChannelFactory.cs, PeerChannelListener.cs,
	  TcpChannelFactory.cs, TcpChannelListener.cs : use above.

2009-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : add ReplyTo header.

2009-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexSessionBase.cs : new file, for session implementation.
	* TcpDuplexSessionChannel.cs, PeerDuplexChannel.cs,
	  DuplexSessionChannelBase.cs : changed sync/async implementation
	  pattern. Now async methods call sync methods using delegates.

2009-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* InputChannelBase.cs, TransportBindingElement.cs, RequestContext.cs:
	  a few minor API fixes.

2009-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncoderFactory.cs : implement CreateSessionEncoder().

2009-05-19  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : add To header.

2009-05-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : fix several SOAP12 fault deserialization in xml
	  parsing.

2009-05-18  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : avoid NRE for null IncomingMessageHeaders.

2009-05-15  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : Reason is mandatory. raise XmlException, and
	  CommunicationException in each CreateFault().

2009-05-15  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : on listener side, get TcpClient at
	  Open(). Some (but not all yet) continuous communication works now.
	  Use ProtocolException. Remove dummy binary session string.

2009-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : more [MC-NMF] implementation. Moved
	  sending/receiving SizedMessageRecord parts to manager class.
	  Handle writer session, though it is likely broken at dictionary
	  writer part (no string is written so far).
	* BinaryMessageEncoder.cs : add writer session and rename reader
	  session.

2009-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : more [MC-NMF] implementation. Via uri
	  is mandatory in initiator preamble packet. Handle Fault reply in
	  initiator preamble.

2009-05-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : ongoing refactoring to collect [MC-NMF]
	  based communication under TcpBinaryFrameManager class.

2009-05-13  Jb Evain  <jbevain@novell.com>

	* MessageHeader.cs: use a SL friendly way of creating an XmlReader
	from a StringReader.

2009-05-13  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs, MessageHeader.cs : eliminate xlinq in 2.1, and
	  actually eliminate DOM-based implementation too in 2.0.

2009-04-28  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : implement in-band dictionary support
	  in [MC-NMF] and [MC-NBFSE], used in duplex channels. Added some
	  comments for magic numbers based on [MC-NMF].

2009-04-28  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : implement part of in-band dictionary
	  support for [MC-NBFSE] record in [MC-NMF], in this class.

2009-04-28  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncodingBindingElement.cs : clear extra public members.

2009-04-27  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpDuplexSessionChannel.cs : implemented some channel methods.

2009-04-27  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : use XmlDictionary specified as [MC-NBFS].

2009-04-27  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelManagerBase.cs : implement Open/CloseTimeout correctly.

2009-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncoder.cs : use quotas in binding element.
	  Implement WriteMessage().

2009-04-22  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerCustomResolverBindingElement.cs : do initialize field.

2009-04-21  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerCustomResolverBindingElement.cs :
	  implement full custom resolver.

2009-04-21  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerDuplexChannel.cs, PeerChannelListener.cs,
	  PeerOutputChannel.cs, PeerCustomResolverBindingElement.cs,
	  PeerChannelFactory.cs : ongoing p2p channel implementation.

2009-04-21  Atsushi Enomoto  <atsushi@ximian.com>

	* PnrpPeerResolverBindingElement.cs : sync with PeerResolver changes.

2009-04-21  Atsushi Enomoto  <atsushi@ximian.com>

	* BinaryMessageEncodingBindingElement.cs, ChannelBase.cs,
	  ChannelFactoryBase.cs, WindowsStreamSecurityBindingElement.cs :
	  implement GetProperty<T>(). Return documented objects or null.

2009-04-20  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerChannelFactory.cs, PeerChannelListener.cs,
	  PeerCustomResolverBindingElement.cs, PeerDuplexChannel.cs
	  PeerInputChannel.cs, PeerOutputChannel.cs :
	  new; ongoing peer transport implementation.
	* DuplexSessionChannelBase.cs, InputChannelBase.cs
	  MsmqOutputChannel.cs, OutputChannelBase.cs,
	  PeerResolverBindingElement.cs, PeerTransportBindingElement.cs,
	  PnrpPeerResolverBindingElement.cs, TcpDuplexSessionChannel.cs :
	  several internal changes (either required or for simplification)
	  for ongoing peer transport implementation.

2009-04-08  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerTransportBindingElement.cs : ListenIPAddress is IPAddress.

2009-04-07  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpTransportBindingElement.cs : check build-ability before
	  actually building channels.
	* ConnectionOrientedTransportBindingElement.cs : fixed build-ability
	  conditions according to MSDN.

2009-03-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs, MessageHeaders.cs, MessageImpl.cs :
	  handle headers in SL2. Slightly changed 3.0 code too.

2009-03-04  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : use cross domain access manager.

2009-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : (in CreateBufferedCopy) do not pass the entire
	  message as BodyWriter.
	  (in GetReaderAtBodyContents) just write body contents.
	* MessageImpl.cs : do not try to read body at ctor (fixed tons
	  of test failures).
	  Add some state check in GetReaderAtBodyContents().
	* XmlReaderBodyWriter.cs : avoid possible extra xmldecl onto output.

2009-02-18  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : do not forget to flush.
	* HttpRequestChannel.cs : give more exact error info.

2009-02-18  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs, MessageBufferImpl.cs, XmlReaderBodyWriter.cs :
	  make buffered copy in ML2 really buffered.

2009-02-12  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : if there is no header item to write, do not write
	  SOAP header element.

2009-01-22  Alan McGovern  <amcgovern@novell.com>

	* MessageHeaders.cs : List<T>.RemoveAll(Predicate<T>) doesn't exist in Silverlight.
	Rewrite to avoid usage of it.

2009-01-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelParameterCollection.cs : implement, rather than NIE.

2008-05-22  Noam Lampert <noaml@mainsoft.com>

	* MessageFault.cs: Correctly serialize ExceptionDetails. Expose SimpleMessageFault to allow
	  internal users to know the type of the detail. 
	
2008-05-20  Noam Lampert <noaml@mainsoft.com>

	* Message.c: Use private setter for state private variable to ease debugging.
				 Modify ToString not to change the state, as it is called quite often by VS debugger
				 
2008-04-21  Roei Erez <roeie@mainsoft.com>

	* HttpChannleManager: Fix for multithreaded use.
	* HttpReplyChannel: Fix crash during sutdown.

2008-04-17  Igor Zelmanovich <igorz@mainsoft.com>

	* HttpChannleManager: ensure trailing slash in uri.

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* added: HttpChannleManager,
	* HttpChannelListener: added use of HttpChannelManager

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* MessageEncodingBindingElement.cs: fixed ctor

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* XmlReaderBodyWriter.cs: fixed ctor, skip xml declaration

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* HttpReplyChannel.cs: fixed TryReceiveRequest, fix message header To

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* MessageFault.cs: fixed CreateFault11, implemented "detail"

2008-04-17  Noam Lampert <noaml@mainsoft.com>

	* HttpReplyChannel.cs: fix API - Fix crash during service shutdown.

2008-04-13  Igor Zelmanovich <igorz@mainsoft.com>

	* BindingElementCollection.cs: fix API - .ctor's signature.

2008-04-10  Eyal Alaluf <eyala@mainsoft.com>

	* XmlSerializerBodyWriter.cs: Removed.

2008-03-25  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* MessageFault.cs: fixed WriteReason, .net XmlWriter compatible

2008-02-20  Atsushi Enomoto  <atsushi@ximian.com>

	* DuplexSessionChannelBase.cs : made it non-session (more reusable).
	* TcpChannelFactory.cs, TcpChannelListener.cs :
	  unify factory and listener into TcpChannelInfo for use in
	  TCP channel implementation. Do not store stream in the listener.
	  Factory now uses BinaryMessageEncoder.
	* TcpDuplexSessionChannel.cs : changes explained above, and now it
	  holds TcpClient that the listener has accepted.

	  tcp-transport-binding-element sample now communicates (though
	  only when both sides are mono: there seems binary mismatch).

2008-02-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpTransportBindingElement.cs, TcpConnectionPoolSettings.cs :
	  clone connection pool settings too.
	* NamedPipetransportBindingElement.cs,
	  NamedPipeConnectionPoolSettings.cs : let's clean them up too (not
	  being likely implemented though).

2008-02-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ConnectionOrientedTransportBindingElement.cs, 
	  TcpTransportBindingElement.cs : some API updates.
	  Initialize default values.
	* TcpConnectionPoolSettings.cs : new file.

2008-02-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceHostParser.cs, SvcHttpHandlerFactory.cs, SvcHttpHandler.cs:
	  added support for "factory" attribute.

2008-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContent.cs : consider HttpResponseMessageProperty.

2008-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : pass response ContentType to ReadMessage().

2008-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : create WebRequest against To message header
	  item (if exists).
	  Consider HttpRequestMessageProperty.
	  Do not output body when suppressed or the method is GET.

2008-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : BindingContext may not have listenUri
	  at its .ctor() step.

2008-02-08  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingContext.cs : RemainingBindingElements is not just a dummy
	  collection but is actually user-controlled.

2008-02-08  Atsushi Enomoto  <atsushi@ximian.com>

	* TcpChannelFactory.cs, TcpChannelListener.cs, 
	  HttpChannelFactory.cs, HttpChannelListener.cs,
	  MsmqChannelFactory.cs, MsmqChannelListener.cs,
	  TextMessageEncodingBindingElement.cs,
	  BinaryMessageEncodingBindingElement.cs,
	  MtomMessageEncodingBindingElement.cs :
	  message encoder should be retrieved only through public API.
	* BindingContext.cs : so my old guess was wrong.

	See also: http://blogs.msdn.com/drnick/archive/2006/05/10/594134.aspx

2008-02-05  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpTransportBindingElement.cs : implemented copy constructor.

2007-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs, HttpReplyChannel.cs : treat SOAPAction HTTP
	  header when AddressingVersion is None.

2007-08-20  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : AddressingVersion.None rejects some WSA
	  property setters.

2007-08-19  Atsushi Enomoto  <atsushi@ximian.com>

	* OneWayBindingElementImporter.cs
	  CompositeDuplexBindingElementImporter.cs : new files.

2007-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : due to the DataContractSerializer.ReadObject()
	  semantic change, its bool parameter must be false, not true.

2007-07-13  Atsushi Enomoto  <atsushi@ximian.com>

	* InputChannelBase.cs, MsmqChannelListener.cs, MsmqInputChannel.cs :
	  new files. Msmq transport listener Implementation.
	* MsmqOutputChannel.cs : implemented Send(). Not sure if it works
	  (wait for System.Messaging impl.)
	* HttpReplyChannel.cs : added comment

2007-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MsmqChannelFactory.cs MsmqOutputChannel.cs OutputChannelBase.cs :
	  new files. internal stuff for msmq channel.
	* BinaryMessageEncoder.cs : added another .ctor().
	* MsmqTransportBindingElement.cs :
	  implemented [Can]BuildChannelFactory().

2007-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MsmqBindingElementBase.cs MsmqTransportBindingElement.cs :
	  initialize some fields.

2007-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MsmqBindingElementBase.cs MsmqMessageProperty.cs
	  MsmqTransportBindingElement.cs ITransactedBindingElement.cs :
	  couple of msmq stubs.

2007-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : SecurityContextToken support (though
	  it is still regarded as invalid by WCF).

2007-03-13  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs, SecureMessageGenerator.cs :
	  make header.Contents.Add() more strict.
	  Use HasAsymmetricKey to determine whether to use asymmetric algorithm
	  or not.
	  Added some hack to allow ssl token external mode.
	  Commented out such lines that always premised asymmtric key.

2007-03-08  Atsushi Enomoto  <atsushi@ximian.com>

	* TransactionFlowBindingElement.cs : forgot necessary Clone().

2007-03-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : support check to create
	  authenticator is now done in both initiator/recipient sides.
	* SecurityRequestContext.cs : don't encrypt WS-Trust RSTR.

2007-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : for now, comment out the code
	  that makes authenticator creation optional.
	* SecurityRequestContext.cs : don't decrypt message when it is
	  WS-Trust messages. Also, do not secure SOAP Fault (it is likely
	  to fail).
	* SecurityChannelListener.cs : GetProperty<T>() now returns
	  MessageSecurityBindingSupport when requested. It is used by
	  EndpointDispatcher to check if it supports WS-Trust negotiation.
	* ChannelListenerBase.cs :
	  removed extra TODO and field. Implemented GetProperty<T>().
	* Message.cs : In CreateMessage() for SOAP Fault, create
	  SimpleMessage with IsFault = true.

2007-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : try to reply fault with the inner
	  channel when an error occurred internally.
	* FaultConverter.cs : implemented based on OperationContext (at normal
	  state it does not seem to create messages, so I implemented it this
	  way).

2007-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* TransportBindingElement.cs : implemented GetProperty<T>().
	* TransactionFlowBindingElement.cs : on building factory or listener,
	  reject channel types that cannot build.
	* SecurityBindingElement.cs : added some TODO comments.
	* HttpTransportBindingElement.cs : GetProperty<T>() should rather
	  delegate to base, not BindingContext.
	* SecurityRequestContext.cs : somewhat late decryption.

2007-03-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs,
	  AsymmetricSecurityBindingElement.cs,
	  SymmetricSecurityBindingElement.cs :
	  renamed *SecurityBindingElementSupport to *SecurityCapabilities and
	  implemented ISecurityCapabilities on them. Now those binding
	  elements support GetProperty<ISecurityCapabilities>().

2007-03-05  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : SetIssuerBindingContextIfRequired()
	  will work only for predefined parameter types.

2007-03-01  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs :
	  Set proper MessageDirection to the requirement after creation.
	  split CreateTokenAuthenticator() as MessageDirection is different.
	  Removed extra creation of requirement.

2007-03-01  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : token authenticator is not
	  always created on channel-opening stage.
	* SecurityBindingElement.cs : use SslSecurityTokenParameters for
	  Sslnego binding factory method.

2007-02-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : inconsistent ReferenceList has caused
	  signature velification failure.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : encrypt signature confirmations only
	  when they are required.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : SignatureConfirmation must be encrypted
	  when [Signature Protection is true i.e. when we use
	  SignBeforeEncryptAndEncryptSignature.

	  With this change finally samplesvc.cs/samplecli.cs became
	  interoperable(!)

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : signature verification was not done
	  for endorsing supporting tokens.
	* SecureMessageGenerator.cs : moved SignatureConfirmation position
	  in the security header. Don't output empty ReferenceList.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : signingToken was added before being
	  initialized and thus caused NRE.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs, SecureMessageDecryptor.cs,
	  SecureMessageGenerator.cs : use SHA1 instead of HMACSHA1. Now we
	  don't need workaround for symmetric key restoration.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs, SecureMessageDecryptor.cs,
	  SecureMessageGenerator.cs :
	  Avoid extra reference search from the request's ReferenceList.
	  create HMACSHA1 always with the key to compute hash (I'm not sure
	  it is correct; it is rather to adjust all hash consistent.)

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : verify that endorsing supporting tokens
	  actually endorsed the primary signature.
	* SecureMessageGenerator.cs : implemented endorsing of the primary
	  signature. So, now supporting tokens are fully implemented.

2007-02-27  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : so, those supporting tokens are
	  totally signing tokens.
	* SecureMessageGenerator.cs : Endorsing tokens should also be
	  included in the message. They are just not signed.

2007-02-26  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : support signing and encryption of
	  supporting tokens. Some required refactory to do it.
	* MessageSecurityBindingSupport.cs : added EncryptedData member.

2007-02-26  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : fix exception message.
	* WSSecurityMessageHeader.cs, WSSignedXml.cs, WSEncryptedXml.cs :
	  XmlNamespaceManager is not required for GetIdElement().

2007-02-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs, WSSecurityMessageHeader.cs :
	  moved decryption part from former file to latter file, to reuse
	  SignedXml instance (though now I doubt how it actually was good)
	  which in turn required to replace EncryptedData in
	  WSSecurityMessageHeader with decrypted one.
	* WSEncryptedXml.cs : similar to WSSignedXml.cs, to handle wsu:Id.

2007-02-21  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : when we create DerivedKeyToken, those
	  EncryptedData should contain KeyInfo as it is not obvious which key
	  is used there. .net<->mono DerivedKeyToken introp is done.
	* SecureMessageDecryptor.cs : check derived key requirement.
	  Reduce dom-dependent parts.

2007-02-21  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : ReferenceList needs to be bound to
	  the related DerivedKeyToken (if any).
	* SecureMessageGenerator.cs : largely done with DerivedKeyToken
	  support. Some refactoring to distinguish deried-token-related
	  variables.
	* SecureMessageDecryptor.cs : removed its own support for derived
	  key tokens. Now it fully works with DerivedKeySecurityToken.

2007-02-21  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs, SecureMessageDecryptor.cs,
	  SecureMessageDecryptor.cs :
	  Implemented increment token reading in o:Security, as
	  DerivedKeyToken could reference to existing wrapped key.
	  Removed WsscDerivedKeyToken and all relevant code.
	* SecureMessageGenerator.cs : replaced WsscDerivedKeyToken with
	  DerivedKeySecurityToken.

2007-02-16  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : it was setting security tokens into
	  incorrect SecurityMessageProperty.
	  Use correct WrappedKeySecurityToken for EncryptedKeySHA1.
	  Now it uses SecurityRequestContext instead of just primary key.
	* SecureMessageDecryptor.cs : removed extra lines. Limit workarounds
	  to symmetric reply decryption, which is the only trouble case.
	  Do not create another SignedXml.
	* WSSecurityMessageHeader.cs : SignedXml processing changes above.

2007-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : Now it uses union token resolver and
	  the resolver works with in-progress token reading in o:Security.
	* WSSecurityMessageHeader.cs : now it does not read EncryptedKey
	  as EncryptedKeyIdentifierClause. It is rather a SecurityToken.
	* SecureMessageGenerator.cs : cosmetic refactoring.

2007-02-14  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : read EncryptedKeyIdentifierClause
	  instead of EncryptedKey.

2007-02-13  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : SigningToken and EncryptionToken
	  should not be always prepared at channel Open(). It also caused
	  that extra token requirements.
	* SecureMessageGenerator.cs : use correct key clause for encryption.
	* SecureMessageDecryptor.cs : reduce extra key acquisition.

2007-02-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : added CreateTokenAuthenticator()
	  for supporting 'supporting tokens' .
	* SecureMessageGenerator.cs : Supporting token creation is done only
	  at initiator (not sure if it is supposed that, but for now it is).
	  Removed extraneous CollectSupportingTokens().
	* SecureMessageDecryptor.cs : implemented supporting token
	  authentication (partly). "Signed" supporting tokens are expected
	  to work fine.

2007-02-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs :
	  make SignBeforeEncryptAndEncryptSignature working.

2007-02-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : EncryptedKeySHA1 needs key hash, not
	  the key itself. ProtectionToken is WrappedKey.
	* SecureMessageDecryptor.cs : now it is internal encrypted key clause,
	  not EncryptedKeyIdentifierClause which is not for embedded key.
	* MessageProperties.cs : Fixed copy direction in CopyProperties().

2007-02-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : added DefaultKeyWrapAlgorithm
	  to switch asymmetric and symmetric. Not used yet.
	* SecurityRequestChannel.cs : now it pass the request security
	  property to reply receiver so that it could use the primary key
	  used at request phase.
	* SecurityRequestContext.cs : now it pass the context itself to
	  reply sender so that it could embed related MessageID.
	* SecureMessageGenerator.cs : ongoing changes to support symmetric
	  binding element. Add RelatesTo output and remove MessageID when
	  replying to the sender. Added some hacks to get symmetric binding
	  (kind of) working.
	* SecureMessageDecryptor.cs : ditto. Handle embedded encryption key
	  in SecurityTokenReference (it also involved existing encrypted key 
	  retrieval). In reply receiver, reuse the key that was used at
	  request phase. It needs significant token resolution refactoring.

2007-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : cosmetic refactoring.
	* SecureMessageDecryptor.cs : store token and its authentication
	  policies into the security property, and reuse it on reply.
	  Some code refactoring; there is at most one o:Security to solve at
	  one endpoint (depends on Actor). Some attempt to use correct
	  token parameters (but for now I have only samples that use x509).
	* SecureMessageGenerator.cs : For replying message, use initiator's
	  signing token as the encryption token. Simply reuse security
	  property from the input message.

	  I have some nasty workaround at decryptor for initiator that could
	  not retrieve decryption key.

2007-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs, SecurityChannelListener.cs,
	  SecurityRequestContext.cs, MessageSecurityBindingSupport.cs:
	  several refactoring on token acquisition. Large part of
	  MessageSecurityBindingSupport code is unified.

2007-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageProperties.cs : Security property should be one of the items.
	  Actually many other properties should be similar as well.
	* MessageImpl.cs, MessageBufferImpl.cs, Message.cs :
	  when copying a message, copy properties as well.
	* SecurityRequestContext.cs : on replying, pass input 
	  SecurityMessageProperty to the security generator.
	* SecureMessageGenerator.cs : both of above, for SignatureConfirmation
	  support.
	* WSSecurityMessageHeader.cs : fixed lazy .ctor() that did nothing.

2007-02-01  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSignedXml.cs:
	  MessageHeader.cs, Message.cs, WSSecurityMessageHeader.cs,
	  SecureMessageDecryptor.cs, SecureMessageGenerator.cs:
	  use new WSSignedXml instead of SignedXml, and remove coexisting
	  Id and wsu:Id. Now we can live only with wsu:Id and therefore
	  - our reply messages could be consumed by .NET, and
	  - .NET signature could be verified.

2007-02-01  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageDecryptor.cs : The signing key must be passed as
	  CheckSignature() argument, not SigningKey.

2007-01-31  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : don't read attribute after ReadStartElement().

2007-01-31  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : some Release() refactoring.
	* SecureMessageGenerator.cs : use correct signing key clause for
	  SecurityTokenReferenceKeyInfo to be serialized.
	* SecureMessageDecryptor.cs : now it can try to parse signature.

2007-01-31  Atsushi Enomoto  <atsushi@ximian.com>

	Ongoing changes to support signature confirmation
	* SecureMessageGenerator.cs :
	  Don't output ReplyTo onto reply message.
	  Write SignatureConfirmation if needed.
	* SecureMessageDecryptor.cs :
	  Some refactoring for header cunsumption. Added commented-out
	  signature verification part (not working yet, on client side due
	  to incorrect reply from service and insufficient clause reader).
	* WSSecurityMessageHeader.cs :
	  Added SignatureConfirmation support.
	  KeyInfoClause for o:SecurityTokenReference should be replaced with
	  SecurityTokenReferenceKeyInfo.

2007-01-29  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : support Timestamp signature.
	  Removed unused code, and extra argument in CreateReference().
	* WSSecurityMessageHeader.cs : Timestamp also needs Id for SignedXml.

2007-01-29  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs :
	  Several fixes to make asymmetric binding working:
	  - Differentiate signing and encryption token in several areas.
	  - Fixed signing keyinfo.
	  Use SenderIdPrefix.
	  Added initial SecurityMessageProperty handling, not sure if it is
	  appropriate here though.
	* HttpRequestChannel.cs : (some debugging lines)

2007-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	Woohoo! Here is a very basic WS-Security compliant message which could
	be allowed by Indigo.
	* MessageHeader.cs : added Id support for writing.
	* Message.cs : added internal BodyId for signature reference.
	* MessageImpl.cs : write Body Id if required.
	* SecureMessageGenerator.cs : Before signing, the target elements must
	  be given wsu:Id. Since I still use System.Security.dll, I need some
	  trick for signing (I give both Id and wsu:Id, former to sign and
	  latter to be consumed). Maybe I will have to replace xmldsig/xmlenc
	  implementation later. Now singning mechanism works except for
	  wsu:Timestamp (which is kind of mandatory).

	I can's still consume replies from Indigo but it's a big progress :)

2007-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaderInfo.cs : added internal Id.
	* MessageHeader.cs : read and write wsu:Id.
	* Message.cs : output wsu namespace if Id exists in any header.
	* HttpReplyChannel.cs : (some debugging lines.)
	* SecureMessageDecryptor.cs : (remove debugging lines.)
	* MessageImpl.cs : removed obsolete code.
	* WSSecurityMessageHeader.cs : output "o" prefix.
	* SecureMessageGenerator.cs : replaced XmlElement-based header
	  signing with MessageHeader-based signing, to support Id correctly.

2007-01-15  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : some more refactoring and code comments.
	* MessageSecurityUtility.cs : made decryptor into an instance class,
	  like I've done for SecureMessageGenerator.
	* SecurityRequestContext.cs, SecurityRequestChannel.cs :
	  dependent changes for above.

2007-01-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : fixed derived keysize. derived key was
	  causing NRE due to the lack of token reference.
	  No need to pass doc to SignedXml.ctor() anymore.
	  Moved ReferenceList before the signature(s).

2007-01-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : add wsu:Timestamp to signing target.
	  Moved signing key generation code to non-HMACSHA1 signing part.
	  Don't try to sign wss:Security.
	  Pass document itself to SignedXml.ctor().
	  Use temporary DataObjects to avoid adding Ids (not sure what is the
	  expected processing yet).
	* WSSecurityMessageHeader.cs : to support timestamp signing, add
	  WriteTo() method in WsuTimestamp.

2007-01-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : wrong key was used for signing.
	  Omit KeyInfo for now - it seems that .net (sometimes?) omits it.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs :
	  Now ID generation process does not modify input message.
	  Moved derived key generation part into (virtual) signing loop.
	  MessagePartSpecification support for signing is done.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : some reordering to handle signing and
	  encryption with supporting tokens. Fixed XPath query bug for
	  soap header contents (we want s:Header/*, not s:Header).

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : more refactoring.
	  Made it abstract and added Initiator- and Recipient- classes.
	  Several members were moved to those derived types.
	* AsymmetricSecurityBindingElement.cs, 
	  SymmetricSecurityBindingElement.cs
	  SecurityChannelFactory.cs, SecurityChannelListener.cs,
	  SecurityRequestChannel.cs, SecurityOutputChannel.cs,
	  SecurityRequestContext.cs, SecureMessageGenerator.cs :
	  All dependent changes by above. Removed ISecurityChannelSource
	  which became useless.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* SecureMessageGenerator.cs : encryption parts should exist too.
	* AsymmetricSecurityBindingElement.cs
	  SymmetricSecurityBindingElement.cs,
	  MessageSecurityBindingSupport.cs : some refactoring.
	  Split MessageSecurityBindingSupport into security binding element
	  specific parts and made MessageSecurityBindingSupport concrete.
	  It is likely split again, next time based on initiator/recipient.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs, SecureMessageGenerator.cs :
	  split encryptor part in the former file into latter file, and
	  make it nonstatic.
	* SecurityRequestChannel.cs, SecurityOutputChannel.cs,
	  SecurityRequestContext.cs : apply the change above.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs :
	  Fixed incorrect TrgGetValue() use.
	  Added CollectRecipientSupportingTokens().

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs: acctually ReferenceList was inside
	  EncryptedKey. So, when a key itself is used to encrypt data,
	  ReferenceList is contained by itself.
	* MessageSecurityBindingSupport.cs :
	  added CollectInitiatorSupportingTokens().

2007-01-10  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs: it should support ReferenceList-less
	  messages.

2007-01-10  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : reverted previous unnecessary change.
	* MessageSecurityUtility.cs : there already was uuid.

2007-01-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : replaced EncryptedKey with
	  WrappedKeySecurityToken, which seems to be in actual use in .net.
	* WSSecurityMessageHeader.cs : added internal Guid so that it
	  could be shared between header items.

2006-12-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestContext.cs, TextMessageEncoder.cs :
	  some null arg check.

2006-12-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : reducing DOM dependency. Use KeyInfoNode
	  for SecurityTokenReference resolution.

2006-12-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : fixed EncryptedData decryption to
	  consider DerivedKeyTokens correctly.
	  When creating LocalId, don't add '#' here.

2006-12-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs :
	  handle key mapping for each wsse:Security.

2006-12-07  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : use prefix "c" for ws-secureconv.

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : write top-level ReferenceList in
	  wsse:Security.
	* MessageSecurityUtility.cs :
	  Now ReferenceList is placed under wsse:Security as WS-Security 1.1 
	  suggests, and it is used to dereference decryption targets.
	  Now it premises multiple wsse:Security elements to read.

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : don't write o:SecurityTokenReference
	  manually (and actually the namespace URI was wrong).

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : improved DerivedKeyToken writing
	  and reading.
	* MessageSecurityUtility.cs : DerivedKeyToken creation.

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs,
	  SymmetricSecurityBindingElement.cs,
	  AsymmetricSecurityBindingElement.cs :
	  implemented SetKeyDerivation().

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : don't add KeyInfoClause to EncryptedKey
	  more than once.

2006-12-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageBufferImpl.cs : XmlReader-based buffer is not possible, so
	  don't use it.

2006-12-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : u:Timestamp will be encrypted/signed,
	  thus move it in front of encryption/signing.

2006-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* TransactionFlowBindingElement.cs : OnOpen()/OnClose() should not
	  check state by themselves (btw it's not really working).
	* HttpChannelListener.cs : If the url does not end with '/' add it
	  so that it could be fed to HttpListener.

2006-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs : check scheme on CreateChannel.
	* MessageHeader.cs : finish IsMessageVersionSupported().

2006-12-04  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultConverter.cs : new file, not used yet though.

2006-10-21  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : set GET URL to ServiceMetadataBehavior.

2006-10-20  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : once AspNetReplyChannel get working with HTTP
	  GET as well as HttpReplyChannel, configuration would be ready now.

2006-10-18  Ankit Jain  <jankit@novell.com>

	* TextMessageEncoder.cs (MediaType): Use 'application/soap+xml' for
	EnvelopeVersion.Soap12 and 'text/xml' for others.
	* HttpReplyChannel.cs (TryReceiveRequest): Revert earlier patch for GET
	handling.
	Strip '?' from the query string.

2006-10-13  Ankit Jain  <jankit@novell.com>

	* MessageVersion.cs (None): Set AddressingVersion.None

2006-10-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SvcHttpHandler.cs : added config-based endpoint addition code.
	  Though due to some weird bug in mono-core it does not seem to work,
	  so commented out for now.
	* HttpReplyChannel.cs : handle wsdl query parameter. btw creating
	  mex request message might just be wrong.
	  Use expected MessageVersion by the channel.
	* AspNetReplyChannel.cs : ditto. Plus, HTTP GET support.

2006-10-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : added DefaultSignatureAlgorithm
	  which differs depending on whether it is asymmetric or symmetric.
	* SecurityRequestChannel.cs, SecurityRequestContext.cs :
	  simplify SecureMessage() and DecryptMessage() arguments (just
	  take MessageSecurityBindingSupport instead of several parameters).
	* MessageSecurityUtility.cs :
	  - simplify SecureMessage() and DecryptMessage() arguments (just
	    take MessageSecurityBindingSupport instead of several parameters).
	  - Take token inclusion mode into account. Don't include them when
	    it is not expected. Also, change the token reference style.
	  - add wsa:MessageID to the headers.
	  - For hmac-sha1 signing (default for symmetric binding), use
	    symmetric key created for encryption as well to create HMACSHA1.
	  - add Id to wsu:Timestamp.
	  - start to handle SecurityMessageProperty.
	* WSSecurityMessageHeader.cs :
	  Added Id to WsuTimestamp. Also use prefixes for its XML output.
	  Changed date format.

2006-10-06  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : reject faulted state on Open()/Close().
	* MessageHeaders.cs : removed extra fields.

2006-10-06  Ankit Jain  <jankit@novell.com>

	* HttpReplyChannel.cs (TryReceiveRequest): Handle HTTP GET.

2006-10-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs, SecurityRequestContext.cs :
	  added some FIXMEs and additional arg.

2006-10-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : remove duplicate Action header.

2006-10-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : partly implemented CreateFault(Message, int).
	* Message.cs, MessageImpl.cs, MessageBufferImpl.cs :
	  handle IsFault correctly in each implementation.

2006-10-04  Ankit Jain  <jankit@novell.com>

	* HttpRequestChannel.cs (ProcessRequest): Read till the end.

2006-10-04  Ankit Jain  <jankit@novell.com>

	* HttpRequestChannel.cs (ProcessRequest): Temporary workaround for a bug
	in WebConnectionStream.

2006-10-04  Ankit Jain  <jankit@novell.com>

	* MessageHeaders.cs (To): Use GetHeader<string> till
	DataContractSerializer gets ISerializable support.
	* CustomBinding.cs (.ctor): Get scheme from TransportBindingElement.

2006-10-04  Ankit Jain  <jankit@novell.com>

	* ServiceHostParser.cs (Parse):
	(Split): Add some error checks.

2006-10-03  Atsushi Enomoto  <atsushi@ximian.com>

	* SslStreamSecurityBindingElement.cs : updated API to Sep. CTP.
	* StreamUpgradeAcceptor.cs : Fix AcceptUpgrade().
	* SslStreamSecurityUpgradeProvider.cs,
	  SslStreamSecurityUpgradeAcceptor.cs :
	  new files for Ssl upgrade provider implementation.
	* MessageSecurityUtility.cs :
	  Create proper C14NTransform. Don't use enveloped signature
	  transform but sign every significant bits. On securing messages
	  use ChannelProtectionRequirements.
	* SecurityRequestContext.cs : pass ChannelProtectionRequirements to
	  SecureMessage().
	* MessageEncoder.cs : fix API (missing constraint).
	* WSSecurityMessageHeader.cs : it is MustUnderstand.
	* StreamUpgradeProvider.cs : API fix and implemented .ctor().
	* AsymmetricSecurityBindingElement.cs : default protection order is
	  SignBeforeEncryptAndEncryptSignature.

2006-09-29  Ankit Jain  <jankit@novell.com>

	* SvcHttpHandlerFactory.cs (GetTypeFromSvc): Extract and move code to
	ServicHostParser and use that here.
	(PrivateBinPath): New.
	(GetTypeFromBin): New. Load assembly from PrivateBinPath.
	(RemovedCallback): Remove and close the SvcHttpHandler when its
	corresponding file (.svc) changes.
	* SvcHttpHandler.cs (Close): New. Close the ServiceHost.

	* ServiceHostParser.cs : New.
	* CachingCompiler.cs : New. Code extracted from
	System.Web.Compilation.CachingCompiler
	* CompilationException.cs : New. From System.Web.Compilation
	* HtmlizedException.cs : New. Likewise.

2006-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : For client side, it is always
	  InitiatorServiceModelSecurityTokenRequirement which should be
	  created. Fixed wrong client encryption key acquisition.

2006-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelListener.cs, SecurityRequestContext.cs,
	  MessageSecurityBindingSupport.cs : made similar changes as factories
	  to listener so that session channels and input channels would work.
	  Added authenticator creation.

2006-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : added missing members.

2006-09-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestChannel.cs, SecurityOutputChannel.cs,
	  MessageSecurityUtility.cs, MessageSecurityBindingSupport.cs :
	  reduce code duplication between request and output channels.
	  The common parts are now in MessageSecurityBindingSupport.
	  Now reduced several arguments in SecureMessage() for client.

2006-09-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : implemented ValidateCreateChannel().

2006-09-28  Atsushi Enomoto  <atsushi@ximian.com>

	* AsymmetricSecurityBindingElement.cs,
	  SecurityChannelListener.cs,
	  SecurityRequestContext.cs,
	  SymmetricSecurityBindingElement.cs,
	  SecurityRequestChannel.cs,
	  SecurityOutputChannel.cs,
	  SecurityChannelFactory.cs,
	  MessageSecurityBindingSupport.cs : 1) Refactoring. 
	  IMessageSecurityBindingSupport now becomes a class and contains
	  all the members which resided in ISecurityChannelSource.
	  Now it takes more constructor params.
	  Made dependent changes on all sources above.

	  2) Added SecurityTokenAuthenticator creation in
	  SecurityRequestChannel (SecurityOutputChannel should do the same).

2006-09-27  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestChannel.cs : ongoing improvements on conditional
	  key creation. Actually there must be some part that creates an
	  authenticator (WinFX does that).

2006-09-27  Ankit Jain  <jankit@novell.com>

	Add suport for handling .svc files.
	* SvcHttpHandlerFactory.cs: New.
	* SvcHttpHandler.cs: New.

	* HttpChannelListener.cs (PopulateChannel): Use AspNetReplyChannel if in
	asp.net environment.
	(OnOpen): Do nothing in asp.net environment.
	(OnClose): Likewise.
	* HttpReplyChannel.cs (HttpRequestContext): Move to ..
	* HttpRequestContext.cs: .. here.

	* AspNetReplyChannel.cs: New.
	* AspNetRequestContext.cs: New.

2006-09-26  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs :
	  Significantly rewritten decryption parts to respect ReferenceList
	  to decrypt (so no workaround anymore).
	  Now e:ReferenceList inside o:Security is treated as the referenced
	  EncryptedType items are encrypted by 1) the derived key which is
	  immediately in front of it, or 2) the default key (it is according
	  to WS-SecureConversation section 9.1). Thus removed immediately
	  previous hack to auto-fill wsu:Id attributes.

	  On securing a message, generate correct Id and add DataReference
	  to ReferenceList properly.

2006-09-26  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : handle ReferenceList. It is being
	  practically used.

2006-09-26  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : handle DerivedKeyToken as a header content.
	  Actually WSSecurityTokenSerializer should be able to consume it, but after
	  spending a lot of time I still cannot successfully read it on WinFX.
	  Skip ReferenceList for now.
	* MessageSecurityUtility.cs :
	  Replaced some string literals with constants.
	  Added some workaround for DerivedKeyToken retrieval.
	  WinFX somehow sends incomplete ISO10126 padding which contains
	  bigger number than the key size and is rejected by EncryptedXml,
	  so added DecryptLax() which processes such ones in PaddingMode.None
	  to workaround it (only for cross-connection between mono and winfx).
	  Added some incomplete implicit wsu:Id processing.
	  Don't try to replace SignedXml with EncryptedData. It is not added
	  to the document tree.

2006-09-25  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : support message signature encryption. Some
	  more refactoring.

2006-09-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : implement Clone(). Remove some MonoTODOs.

2006-09-22  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : fix warnings.

2006-09-22  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : actually there would be more than one
	  EncryptedData. Decrypt all.

2006-09-22  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : supply correct URIs in SecureMessage().
	  Use ISO10126 padding mode (it is not required but in manner).

2006-09-21  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : now that EncryptedXml decryption bug is
	  fixed, remove 16 bytes workaround (we still need encryption bugfix in
	  that class to make it work fine with mono client).
	  Removed buggy lines that reset decryption key to AES.
	  Modified GetKey() argument to take EncryptedData/EncryptedKey element.
	* WSSecurityMessageHeader.cs :
	  (SecurityTokenReferenceKeyInfo) support LoadXml.

2006-09-20  Atsushi Enomoto  <atsushi@ximian.com>

	* TransactionMessageProperty.cs : new file.

2006-09-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelPoolSettings.cs, OneWayBindingElement.cs : build fix, as
	  gmcs happened to report wrong code.

2006-09-19  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelFactory.cs, SecurityChannelListener.cs :
	  .ctor() now requires ChannelProtectionRequirements which will be
	  supplied via BindingParameterCollection.
	* SymmetricSecurityBindingElement.cs,
	  AsymmetricSecurityBindingElement.cs : thus add
	  ChannelProtectionRequirement parameter to factory/listener.
	* SecurityRequestChannel.cs : use recipient token requirement to
	  create an encryption token. Thus differentiate the logic from
	  signing (initiator) token.

2006-09-19  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelFactory.cs, SecurityChannelFactory.cs :
	  renamed former to latter.
	* SymmetricSecurityChannelListener.cs, SecurityChannelListener.cs :
	  ditto.

2006-09-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityBindingSupport.cs : new internal types to commonize
	  AsymmetricSecurityBindingElement and SymmetricSecurityBindingElement
	  and thus make internal factory and listener reusable.
	* SymmetricSecurityChannelFactory.cs, SecurityRequestContext.cs,
	  SecurityRequestChannel.cs, SecurityOutputChannel.cs,
	  SymmetricSecurityChannelListener.cs : rewrote dependent parts on
	  SymmetricSecurityBindingElement, using the new types above.
	* SymmetricSecurityBindingElement.cs :
	  Use SymmetricMessageSecurityBindingSupport.
	* AsymmetricSecurityBindingElement.cs :
	  thus implemented, using AsymmetricMessageSecurityBindingSupport.

2006-09-19  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : more RC1 update.

2006-09-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncoder.cs, BinaryMessageEncoder.cs, MtomMessageEncoder.cs,
	  TextMessageEncoder.cs : updated ReadMessage() API to RC1.
	* ChannelListenerBase.cs, ChannelListenerBase_1.cs,
	  ChannelBase.cs : RC1 API updates.
	* MessageImpl.cs : implemented Properties.
	* HttpReplyChannel.cs : added HttpRequestMessageProperty support.

2006-09-18  Ankit Jain  <jankit@novell.com>

	* MessageHeaders.cs (MessageId):
	(RelatesTo): UniqueId is not serializable, serialize it as a string.

2006-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelParameterCollection.cs : new file.
	* LayeredOutputChannel.cs, SecurityOutputChannel.cs :
	  new files for IOutputChannel implementation.
	* OneWayBindingElement.cs : hacky implementation.
	* SymmetricSecurityChannelFactory.cs : support IOutputChannel.
	* MessageSecurityUtility.cs : now create identifier from the security
	  token and the token parameters which is added as an argument.
	* SecurityRequestContext.cs,
	  SecurityRequestChannel.cs : SecureMessage() argument changes.
	  Set MessageSecurityVersion (SecurityTokenVersion) to the token
	  requirement.

2006-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : close the HttpWebRequest.

2006-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs,
	  HttpChannelFactory.cs : implement async request/reply.
	* HttpChannelFactory.cs :
	  verify factory state when creating a channel.

2006-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncoder.cs, TextMessageEncoder.cs, MtomMessageEncoder.cs,
	  BinaryMessageEncoder.cs : added message version mismatch check.

2006-09-15  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelListener.cs, SecurityRequestContext.cs :
	  Making incomplete changes to handle different tokens for encryption
	  and signature.
	* SymmetricSecurityChannelFactory.cs, SecurityRequestChannel.cs :
	  split channel implementation classes out to the latter file.
	* MessageSecurityUtility.cs : seems like there is
	  TimeStampValidityDuration property, so use it (incomplete; a server
	  needs another love).

2006-09-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs, SymmetricSecurityChannelFactory.cs,
	  SecurityRequestContext.cs : now that we have key identifier clause
	  and working ResolveKeyIdentifierClause(), just create keys inside
	  SecureMessage(). Add KeyInfo to the xmldsig.

2006-09-12  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelFactory.cs, SecurityRequestContext.cs :
	  pass SecurityKeyIdentifierClause to SecureMessage().
	* SecurityBindingElement.cs : set X509ReferenceStyle as Thumbprint
	  for IssuedToken binding element.
	* SymmetricSecurityChannelListener.cs : removed hack to just create
	  X509 security token, and implemented correct token creation.
	* WSSecurityMessageHeader.cs : added new KeyInfoClause type that
	  wraps SecurityTokenReference element.
	* MessageSecurityUtility.cs : use the above.

2006-09-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs : raise MessageSecurityException when it
	  could not find a security header.
	* SymmetricSecurityChannelFactory.cs : now it also supports
	  IRequestSessionChannel. Extracted SecurityRequestChannel out from
	  the factory type.

2006-09-08  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : moved securing message part to
	  MessageSecurityUtility.cs.
	* MessageSecurityUtility.cs : the change above.
	  use DateTime.Now for timestamp basis. Don't append signature to
	  the document. Instead it is added to the header. Capture body
	  content instead of the body itself.
	* SymmetricSecurityChannelFactory.cs : decrypt reply message to
	  be processed by upper layers.

2006-09-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageSecurityUtility.cs, WSSecurityMessageHeader.cs,
	  SymmetricSecurityChannelListener.cs,
	  SymmetricSecurityChannelFactory.cs, SecurityRequestContext.cs :
	  more refactoring. Request serialization became much more conformant
	  and add required header items.
	  Security Token retrieval is needed to send it in the request.
	  Fixed wrong key encryption.

2006-09-07  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : the workaround was not functional.

2006-09-07  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : some more refactoring. Use EncryptedXml
	  API, especially ReplaceData(), instead of native crypto stuff.
	* WSSecurityMessageHeader.cs : handle dsig:Signature as well (for
	  MessageProtectionOrder.SignBeforeEncrypt).

2006-09-07  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : label should be combined of both
	  the client's and the server's.

2006-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : enable key derivation (though for now
	  GenerateDerivedKey() is unimplemented). Create meaningful,
	  decrypted request message to be consumed by the upper layer.

2006-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : implement Close() and Reply().
	  ongoing implementation of Reply(TimeSpan).
	* MessageSecurityUtility.cs : new file to collect utility methods.
	* SymmetricSecurityChannelFactory.cs : moved securing message code
	  to the above file.
	* SymmetricSecurityChannelListener.cs : tiny renaming.

2006-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityRequestContext.cs : security header is also stored.
	  removed NotImpl.
	* WSSecurityMessageHeader.cs : read EncryptedKey and EncryptedData
	  as well.

2006-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelFactory.cs : tiny progress on securing
	  message.

2006-09-05  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelFactory.cs : specify KeyUsage.Exchange
	  so that it retrieves the security key in that manner.

2006-09-05  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : MessageVersion is null when there is no
	  MessageEncodingBindingElement.
	* Message.cs : null arg check.

2006-09-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelPoolSettings.cs, OneWayBindingElement.cs : new files.

2006-09-04  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityChannelListener.cs, SecurityRequestContext.cs, 
	  LayeredReplyChannel.cs, LayeredCommunicationObject.cs,
	  LayeredRequestChannel.cs : some refactoring.
	* SymmetricSecurityChannelFactory.cs :
	  ongoing secure message creation implementation.

2006-09-01  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs :
	  pass specific ServiceCredentialsSecurityTokenManager type to
	  SymmetricSecurityChannelListener as it needs ServiceCertificate.
	* SymmetricSecurityChannelListener.cs :
	  get service certificate. It's a temporary hack.
	  Move RequestContext code to below.
	* SecurityRequestContext.cs : new file.
	* WSSecurityMessageHeader.cs : implementing Read(), but to finish
	  it I have to finish decryption of the incoming message.

2006-08-31  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : don't write attributes on the first body content
	  element *on soap Body element*.
	* MessageBufferImpl.cs : don't throw ArgumentNullException.
	  ObjectDisposedException is appropriate.
	* MessageHeader.cs : (RawMessageHeader) don't write element itself
	  in OnWriteHeader*Contents*().

2006-08-31  Atsushi Enomoto  <atsushi@ximian.com>

	* WSSecurityMessageHeader.cs : new file.
	* SymmetricSecurityChannelFactory.cs :
	  moved WSSecurityHeader and related types to the above.
	* SymmetricSecurityChannelListener.cs :
	  reject SOAP-env-less message.

2006-08-31  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelListener.cs, SymmetricSecurityChannelListener.cs :
	  renamed former to latter.
	* SymmetricSecurityChannelFactory.cs :
	  create requirements every time. It is also likely that I need
	  another requirement instance to get service credentials here.

2006-08-30  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs : make BuildChannelListener()
	  similar to BuildChannelFactory() (set credentials, issuer binding
	  context etc.).
	* SecurityChannelListener.cs :
	  more ongoing security support implementation.
	* SymmetricSecurityChannelFactory.cs :
	  moved GetSecurityKey() to SymmetricSecurityRequestChannel.

2006-08-29  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelListener.cs, SymmetricSecurityBindingElement.cs :
	  Renamed SecurityChannelListener to SymmetricSecurityChannelListener.
	  Implementation is underway.
	* LayeredReplyChannel.cs :
	  like LayeredRequestChannel, use ChannelListenerBase to provide
	  default timeouts.

2006-08-29  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : added another implementation type that uses
	  XmlElement, for buffering purpose.
	* MessageImpl.cs : Header item types are user-driven by
	  MessageHeader.GetHeader<T>(int), so at storing phase just store
	  nodes as XmlElement.
	* MessageHeaders.cs : avoid dumping XmlNode to string to create
	  another XmlReader.

2006-08-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs : find ClientCredentials from
	  BindingParameterCollection, not from binding element properties.

2006-08-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelFactory.cs, SymmetricSecurityChannelFactory.cs :
	  renamed former to latter.

2006-08-25  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : SetIssuerBindingContext should also
	  work for SslSecurityTokenParameters.

2006-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs :
	  Added SetIssuerBindingContextIfRequired().
	* SecurityChannelFactory.cs :
	  Changed .ctor() arg again, just to receive binding element.
	* SymmetricSecurityBindingElement.cs :
	  Call SetIssuerBindingContextIfRequired() in BuildChannelFactory().
	  SymmetricSecurityChannelFactory .ctor() arg changes.
	  "ProtectionTokenParameters" is not passed now.

2006-08-23  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs : requirements should be
	  filled at InitializeSecurityTokenParameters as long as possible.
	  SymmetricSecurityChannelFactory<T> now does not receive
	  requirements (it now creates one inside it) at .ctor().
	* SecurityChannelFactory.cs : remove requirement argument.

2006-08-23  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs : implemented copy constructor.

2006-08-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs :
	  MessageSecurityVersion property is of type SecurityTokenVersion.
	* SecurityBindingElement.cs :
	  Implemented CreateSecureConversationBindingElement().
	  For CreateIssuedTokenBindingElement(), ProtectionTokenParameters is
	  the argument IssuedSecurityTokenParameters itself.

2006-08-22  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs :
	  CreateSecurityTokenManager() can be directly used now. 
	  Use CallInitializeSecurityTokenRequirement() to fill requirement
	  properties.

2006-08-16  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : GetProperty() is virtual.

2006-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs : in BuildChannelFactory(),
	  create token manager, token parameters and token requirements,
	  and fill some requirements.
	* TransportBindingElement.cs, HttpTransportBindingElement.cs,
	  TextMessageEncodingBindingElement.cs : workaround to not throw NIE.
	* BindingContext.cs : implemented RemainingBindingElements.
	  kill "no remaining binding element" error in GetInnerProperty()
	* SecurityChannelFactory.cs : now it became 
	  SymmetricSecurityChannelFactory, thus soon to be renamed.
	  Several ongoing actual security resolution is on.

2006-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs :
	  add GetCommunicationObjectType() and use it.
	* ChannelFactoryBase.cs, ChannelListenerBase_1.cs :
	  use ThrowIfDisposedOrNotOpen().
	* LayeredCommunicationObject.cs : have similar ThrowIf...() methods
	  to CommunicationObject. Make it IDisposable.
	* LayeredRequestChannel.cs : use above.
	* SecurityChannelFactory.cs : removed state check as it is done at
	  above class.

2006-08-10  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : (CanBuildChannelFactory and
	  CanBuildChannelListener) directly dispatch to BindingContext.
	* SymmetricSecurityBindingElement.cs : require protection token
	  parameters before building a channel or a listener.
	* ChannelFactoryBase.cs : raise an error when a channel is being
	  created without opening the factory.
	* ChannelListenerBase_1.cs : ditto for the listener.
	* SecurityChannelFactory.cs : before sending a request, it must be
	  opened.

2006-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageBufferImpl.cs : initialize fields.
	  workaround BufferSize just to return 0.
	* MessageImpl.cs : for BodyWriter, don't use DefaultMessageBuffer
	  which does not support multi time write.
	* Message.cs : implemented State.

2006-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : OnGetBodyAttribute() cannot return anything unless it
	  is consuming XmlReader.
	  Implemented OnCreateBufferedCopy(), to return XPathMessageBuffer.
	* MessageBuffer.cs : implemented CreateNavigator().
	* MessageBufferImpl.cs : added XPathMessageBuffer class.

	I kinda know that MS heavily depends on binary XmlReader and may have
	XPathNavigator implementation based on the binary stuff, but at
	least for now we have almost no motivation to mimick it.

2006-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityChannelFactory.cs : a bit more of security header code.

2006-08-04  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs :
	  set default MessageProtectionOrder in every construction.

2006-08-03  Atsushi Enomoto  <atsushi@ximian.com>

	* LayeredRequestChannel.cs, SecurityChannelFactory.cs : 
	  changed to require ChannelFactoryBase to support default timeout.
	  Made some methods non-virtual. Preparing code to add security
	  headers (empty yet).
	* SecurityBindingElement.cs : implemented several factory methods
	  that return SymmetricSecurityBindingElement.

2006-08-02  Atsushi Enomoto  <atsushi@ximian.com>

	* IStreamUpgradeBindingElement.cs,
	  StreamUpgradeBindingElement.cs : renamed from former to latter.

2006-08-02  Atsushi Enomoto  <atsushi@ximian.com>

	* IStreamUpgradeBindingElement.cs : API update, soon to be renamed.

2006-07-31  Ankit Jain  <jankit@novell.com>

	* MessageHeaders.cs (From): Use Constants.WSA1
	(MessageId): Implement the same pattern as other properties (From etc).

2006-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* LocalClientSecuritySettings.cs : initialize IdentityVerifier as well.
	* SecurityBindingElement.cs : some cosmetic changes.

2006-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs : LocalClientSettings and 
	  LocalServiceSettings returns an instance for each.
	* LocalClientSecuritySettings.cs : initialized fields.

2006-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* LocalClientSecuritySettings.cs : moved from S.SM.Description, and
	  kinda implemented Clone() just with MemberwiseClone().

2006-07-27  Ankit Jain  <jankit@novell.com>

	* MessageHeaders.cs (set_To): Use Uri.AbsoluteUri .
	* MessageHeader.cs (knownTypes): New. Known type array containing
	EndpointAddress10.
	(CreateHeader): Use knownTypes with the DataContractSerializer .ctor

2006-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* LayeredRequestChannel.cs, LayeredReplyChannel.cs,
	  LayeredCommunicationObject.cs,
	  SecurityChannelFactory.cs, SecurityChannelListener.cs :
	  new files to support security channels, though right now they
	  just pass inner channels through.
	* SymmetricSecurityBindingElement.cs : use above.

2006-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* AsymmetricSecurityBindingElement.cs,
	  SymmetricSecurityBindingElement.cs :
	  Default SecurityTokenParameters is null.

2006-07-20  Atsushi Enomoto  <atsushi@ximian.com>

	* AsymmetricSecurityBindingElement.cs : remove NotImpl for now.

2006-07-20  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : When EnvelopeVersion is None, don't write SOAP
	  envelope.
	* MessageHeader.cs : don't write headers when EnvelopeVersion is None.
	* MessageHeaders.cs : When EnvelopeVersion is None, don't output
	  headers. When AddressingVersion is None, don't output addressing
	  headers as well, except for Action which is still needed by
	  service dispatcher.

2006-07-20  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : changed specific properties to find it from
	  headers as Action property does (local variables won't be set by
	  setter). Cache serializers. Check null serializer arguments.
	  For EndpointAddress, GetHeader<T>() shouldn't use serializer.

2006-07-19  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : WriteTo() should treat EndpointAddress to not
	  use XmlObjectSerializer (since it is not data contract type).

2006-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : Improved ReadHeaders().
	  For certain header items, use EndpointAddress.ReadFrom().

2006-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* AsymmetricSecurityBindingElement.cs :
	  it is not ISecurityCapabilities anymore.

2006-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageVersion.cs : added None.

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : GetReaderAtBodyContents() implementation using
	  writer methods.

2006-07-13  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : CreateMessage(version,action,xmlReader) incorrectly
	  used MessageVersion.Default.

2006-07-12  Duncan Mak  <duncan@novell.com>

	* MessageBuffer.cs (MessageContentType): Return
	"application/soap+msbin1".

	* MessageImpl.cs (EmptyMessage.OnCreateBufferedCopy):
	(SimpleMessage.OnCreateBufferedCopy):
	(XmlReaderMessage.OnCreateBufferedCopy): Hook up with the new
	MessageBuffer implementations.

	* MessageBufferImpl.cs: Concrete implmentations for MessageBuffer.
	(DefaultMessageBuffer): Used by EmptyMessage and SimpleMessage.
	(XmlReaderMessageBuffer): Used by XmlReaderMessage.

2006-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : Action should be added in request messages. Omit
	  it only in reply message, thus moved to dispatcher logic.

2006-07-12  Ankit Jain  <jankit@novell.com>

	* HttpRequestChannel.cs (HttpRequestChannel.Request): Workaround for a
	bug in WebConnectionStream.
	* MessageHeaders.cs (MessageHeaders.From):
	(MessageHeaders.ReplyTo):
	(MessageHeaders.To): Add the corresponding MessageHeader on set.

2006-07-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : when AddressingVersion is None (e.g. POX), don't
	  add SOAP Action to the response at any time.

2006-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* SymmetricSecurityBindingElement.cs,
	  SecurityBindingElement.cs : They are not ISecurityCapabilities now.
	  Implemented .ctor() and some properties.

2006-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* TransactionFlowBindingElement.cs : new file.
	* HttpTransportBindingElement.cs : added missing KeepAliveEnabled.

2006-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs :
	  DefaultAction vanished. CreateFault() now takes bufferSize arg.
	* MessageHeaders.cs : ArgumentException -> MessageHeaderException.
	* AddressingVersion.cs : added None. Equals() and GetHashCode()
	  vanished (there is anyways no way to instantiate this type).
	* MessageVersion.cs : added Soap11 and Soap12.
	* TextMessageEncoder.cs : silly quotation mark wrapper disappeared
	  in June CTP. goodie.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MtomMessageEncoder.cs, BinaryMessageEncoder.cs, Message.cs :
	  removed some vanished CreateMessage() overloads.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomBinding.cs, HttpsTransportBindingElement.cs, 
	  HttpTransportBindingElement.cs :
	  They are not ISecurityCapabilities anymore.
	  Modified code to match June CTP behavior.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* StreamSecurityUpgradeProvider.cs : Identity -> EndpointIdentity.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* EmptyFaultException.cs : removed unused code.
	* IRequestContext.cs, RequestContext.cs : renamed former to latter.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* LayeredChannelFactory.cs : removed obsolete class.
	* ChannelFactoryBase.cs, HttpChannelFactory.cs,
	  ChannelListenerBase.cs, HttpChannelListener.cs,
	  HttpReplyChannel.cs, ChannelManagerBase.cs :
	  all those changes were brought by ChannelManagerBase changes.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs, HttpChannelFactory.cs, ChannelBase.cs
	  CommunicationObject.cs, HttpChannelListener.cs,
	  ChannelFactoryBase.cs :
	  CommunicationObject abstract changes brought this madness.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingContext.cs : listenUri address parameters could be null in
	  June CTP.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* IRequestContext.cs :
	  Now it became a class. File renaming will follow soon.
	* IChannelFactory.cs, IInputChannel.cs, IReplyChannel.cs,
	  IDuplexChannel.cs, IDuplexSessionChannel.cs,
	  IOutputChannel.cs, IOutputSessionChannel.cs,
	  IRequestChannel.cs, IRequestSessionChannel.cs :
	  They are not IDisposable anymore.
	  For IReplyChannel, IRequestContext -> RequestContext.
	* IChannelListener.cs : removed Identity. Added GetProperty().
	* ChannelListenerBase.cs, ChannelListenerBase.cs,
	  ReplyChannelBase.cs, HttpReplyChannel.cs :
	  Several members disappeared, and dependent changes.
	* HttpTransportBindingElement.cs,
	  HttpChannelListener.cs, :
	  ChannelListenerBase.SharedChannelListener vanished.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncodingBindingElement.cs
	  MtomMessageEncodingBindingElement.cs,
	  TextMessageEncodingBindingElement.cs,
	  BinaryMessageEncodingBindingElement.cs :
	  June CTP updates: AddressingVersion -> MessageVersion.
	* Binding.cs : June CTP. MessageVersion is added.
	* ChannelBase.cs, BindingContext.cs, IChannel.cs
	  ChannelListenerBase_1.cs,
	  ChannelListenerBase.cs, IChannelListener.cs,
	  IChannelFactory.cs,
	  ChannelFactoryBase.cs, ChannelManagerBase.cs :
	  June CTP. Several interface changes.
	* HttpTransportBindingElement.cs : June CTP. HttpMappingMode is gone.
	* IChannelManager.cs, LayeredChannelListener.cs,
	  GenericWrapperChannelFactory.cs,
	  GenericWrapperChannelListener.cs : They are not used anymore.

2006-07-04  Atsushi Enomoto  <atsushi@ximian.com>

	* MtomMessageEncoder.cs, BinaryMessageEncoder.cs :
	  sync fix with June CTP API updates.

2006-07-03  Ankit Jain  <jankit@novell.com>

	* MessageEncodingBindingElementConverter.cs:
	* StandardBindingConverter.cs:
	* TransportBindingElementConverter.cs:
	* TransactionFlowBindingElementConverter.cs:
	* ReliableSessionBindingElementConverter.cs:
	* SecurityBindingElementConverter.cs:
	Rename *Converter.cs to *Importer.cs

	* TransferMode.cs: Move to System.ServiceModel

2006-06-22  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : make sure to change State before
	  OnClosing/OnClosed/OnOpening/OnOpened when they are overriden.

2006-06-20  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : output WSAddressing xmlns only when Action is
	  specified (To should be affected, but seems like it is ignored).

2006-06-20  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : don't set Action when it is null.

2006-06-12  Ankit Jain  <jankit@novell.com>

	* TransportBindingElementConverter.cs (ImportEndpoint): Implement.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* SecurityBindingElement.cs, SecurityBindingElementConverter.cs :
	  some updated API fixes.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* EnvelopeVersion.cs : moved back to S.SM.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* IBindingManualAddressing.cs : vanished in beta2.
	* HostedTransportConfiguration.cs, EnvelopeVersion.cs,
	  LocalClientSecuritySettings.cs, LocalServiceSecuritySettings.cs :
	  namespace changes.
	* SecurityBindingElement.cs :
	  SecurityStandardsManager -> SecurityTokenSerializer.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlSerializerBodyWriter.cs : new file to handle 
	  TypedMessageConverter.ToMessage().

2006-04-26  Ankit Jain  <jankit@novell.com>

	* TransportBindingElementConverter.cs (BeforeImport): Remove
	NotImplementedException.
	(ImportContract): Likewise.
	* CustomBinding.cs (.ctor): Use scheme from the binding parameter.

2006-04-14  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs, HttpChannelFactory.cs : message encoder 
	  being used was not reflecting that of Binding elements.

2006-04-07  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : when SOAP action is not set as a header item,
	  just assume that it is in the message.

2006-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : actually HTTP header item might be null.

2006-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : under SOAP 1.1 SOAP Action is sent as HTTP
	  header.

2006-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* TextMessageEncoder.cs : for SOAP 1.1 content type is text/xml.

2006-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : Fixed SOAP12 reason output.

2006-04-05  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : no need to set response ContentEncoding since
	  MessageEncoder.ContentType explicitly contains encoding.
	* AddressingVersion.cs : added ActionNotSupported property. Not sure
	  if it is SOAP version dependent.

2006-03-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpReplyChannel.cs : actually I could just workaround bug #77816.

2006-03-16  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs BindingContext.cs
	  HttpChannelListener.cs HttpTransportBindingElement.cs :
	  Now BindingContext holds MessageEncoder, and non-custom
	  channel factory/listener should use it.
	* MtomMessageEncodingBindingElement.cs
	  TextMessageEncodingBindingElement.cs
	  BinaryMessageEncodingBindingElement.cs : BuildChannelFactory()/
	  -Listener() now sets internal BindingContext.MessageEncoder.
	  Fixed some public API.

2006-03-15  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingContext.cs : CanBuildChannelXXX() should not raise error
	  for insufficient elements.
	* DispatchRuntime.cs : OperationDescription name is not action. So
	  OperationSelector is created by name, not by action.
	* TextMessageEncodingBindingElement.cs : Feb. CTP API fixes.

2006-03-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFaultBodyWriter.cs
	  XmlReaderBodyWriter.cs
	  XmlObjectSerializerBodyWriter.cs : made internal.
	* SecurityBindingElement.cs
	  AsymmetricSecurityBindingElement.cs
	  SymmetricSecurityBindingElement.cs : API fixes.
	* TransportBindingElementConverter.cs : ditto.
	* TextMessageEncodingBindingElement.cs : added set_AddressingVersion.
	* WindowsStreamSecurityBindingElement.cs
	  SslStreamSecurityBindingElement.cs
	  TransportSecurityBindingElement.cs : new files.

2006-03-14  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : according to the W3C REC, mustUnderstand when
	  reading can be any xs:boolean value.

2006-03-14  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs MessageImpl.cs : more sorting out the role of each
	  write method.
	* MessageHeader.cs : use envelope namespace, not addressing namespace.

2006-03-14  Atsushi Enomoto  <atsushi@ximian.com>

	* Message.cs : don't write body contents if it is empty.
	  Moved WriteStartElement(,"Header",) to OnWriteStartHeaders().
	* MessageImpl.cs : implemented XmlReaderMessage.OnWriteBodyContents().
	* TextMessageEncoder.cs : WriteMessage() should close XmlWriter.
	* HttpRequestChannel.cs : close request stream before GetResponse().

2006-03-13  Atsushi Enomoto  <atsushi@ximian.com>

	* TextMessageEncoderFactory.cs
	  TextMessageEncoder.cs : encoder does not hold reference to the
	  factory anymore. Use MessageVersion property in CreateMssage().
	* HttpChannelListener.cs : now it holds message encoder.
	* HttpReplyChannel.cs : now it uses listener's shared message encoder.
	* MessageImpl.cs : header is optional.
	* EnvelopeVersion.cs : namespace URI is missing.

2006-03-10  Atsushi Enomoto  <atsushi@ximian.com>

	* CustomBinding.cs : removed Initialize().
	* Message.cs : renamed ForwardingMessage -> XmlReaderMessage.
	* MessageImpl.cs : renamed ForwardingMessage to XmlReaderMessage (used
	  by Message.CreateMessage(MessageVersion,XmlReader,int) and
	  implemented Headers, IsEmpty and GetReaderAtBodyContents().

2006-03-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeaders.cs : implemented GetReaderAtHeader() and Action (it
	  could be also added by Add() method and could be reset by Remove()).
	* MessageImpl.cs : implemented more. As noted above, Now we don't 
	  have to add Action header explicitly.
	* MessageHeader.cs : recovered Writer methods and ToString() from
	  commented old version. Use prefixes for writing.
	  Use WriteObjectContent() rather than WriteObject() (it needs
	  DataContractSerializer fix btw).

2006-03-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageHeader.cs : added missing IsReferenceParameter.
	* MessageHeaderInfo.cs : added missing IsReferenceParameter.
	* MessageHeaders.cs : avoid NullRef when actors is null.
	* MessageImpl.cs : (MessageImplBase) add Action header in .ctor().
	  (ForwardingMessage) reader consumer is being added (not done).
	* MtomMessageEncodingBindingElement.cs : simply use Mtom factory.
	* MtomMessageEncoder.cs : updated ContentType value to Feb. CTP.
	* HttpRequestChannel.cs : this channel automatically call Open()
	  when Request() is called. Set content length for request.
	  Use MessageEncoder's ContentType to also handle charset.

2006-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageImpl.cs : make them internal.
	* HttpReplyChannel.cs : set HttpListenerResponse properties correctly.

2006-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelManagerBase.cs : cleanup MonoTODO and unused field.
	* HttpChannelListener.cs : removed commented line.
	* RequestChannelBase.cs : new base class for request channel classes.
	* ChannelListenerBase.cs : OnEndClose() is rather NotImplemented yet.
	* HttpReplyChannel.cs : WaitHandle accepts limited timeout value.
	* Message.cs : default IsEmpty and IsFault false by default.
	* LayeredChannelListener.cs : removed Uri (no chance to set).
	* ChannelBase.cs : reimplemented timeout properties.
	* HttpRequestChannel.cs : now it is mostly based on
	  RequestChannelBase. Some more attempt to implement Request().

2006-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs CustomBinding.cs : removed OnApplyConfiguration() and
	  OnInitialize(). Added more BuildChannelListener() overloads.

2006-03-06  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : added some more missing members especially to support
	  listener creation.
	* HttpChannelListener.cs : Uri should not be null.
	* HttpTransportBindingElement.cs : implemented
	  CanBuildChannelFactory() and CanBuildChannelListener().
	* ServiceHostBase.cs : make Initialize() practically work at OnOpen().

2006-03-06  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : updated default namespace property value to Feb. CTP.

2006-03-03  Atsushi Enomoto  <atsushi@ximian.com>

	* AddressHeader.cs : avoid null reference when value is null.
	* BindingContext.cs : check null ListenUri args.

2006-03-03  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageFault.cs : Fixed default action name. Null arg check.

2006-03-03  Atsushi Enomoto  <atsushi@ximian.com>

	* BindingElement.cs : Dequeue elements in BindingContext directly.
	* BindingContext.cs : Added GetProperty<T>().
	* GenericWrapperChannelFactory.cs GenericWrapperChannelListener.cs :
	  Now we don't need these extra classes, so marked as deprecated.

2006-03-03  Atsushi Enomoto  <atsushi@ximian.com>

	* Binding.cs : null arg check.
	* AddressingVersion.cs : fixed constants to pass the tests.
	* BindingElement.cs : tiny meessage fix.

2006-03-02  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncodingBindingElement.cs
	  BinaryMessageEncodingBindingElement.cs
	  TextMessageEncodingBindingElement.cs
	  MtomMessageEncodingBindingElement.cs
	  MessageEncodingBindingElementConverter.cs : several API fixes.
	* BindingElement.cs : now if we use generic wrapper it causes
	  infinite loop, so for now replace it with most-possible-but-
	  untested logic.

2006-03-02  Atsushi Enomoto  <atsushi@ximian.com>

	(back to normal "record-ChangeLogs" mode after the big API change mess)
	* HttpTransportBindingElement.cs : fixed minor API differences.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* AsymmetricSecurityBindingElement.cs SecurityBindingElement.cs
	  SymmetricSecurityBindingElement.cs :
	  Dependent fixes for System.IdentityModel reorgainzation.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* InputChannelBase.cs.notused IInputSession.cs IOutputSession.cs
	  IProxyFormatter.cs WSHttpBindingBase.cs 
	  PnrpPeerResolverBindingElement.cs IMessageHeaderInfo.cs
	  MessageInterceptorEventArgs.cs WSHttpBinding.cs
	  WSFederationBinding.cs ISessionChannel.cs
	  CompositeDuplexBindingElement.cs MessageVersion.cs
	  MessageHeader.cs IRequestSessionChannel.cs 
	  BindingElementCollection.cs IReplySessionChannel.cs
	  MessageProperties.cs IDuplexClientChannel.cs
	  IInputSessionChannel.cs MessageImpl.cs IDuplexSessionChannel.cs
	  TcpTransportBindingElement.cs EmptyFaultException.cs
	  IBindingRuntimePreferences.cs AddressHeaderCollection.cs
	  IStubFormatter.cs AsymmetricSecurityBindingElement.cs
	  ConnectionOrientedTransportBindingElement.cs
	  IProxyOperationSelector.cs MessageBuffer.cs IChannel.cs
	  PeerResolverBindingElement.cs Message.cs
	  HttpsTransportBindingElement.cs BindingElement.cs
	  NamedPipetransportBindingElement.cs IBindingManualAddressing.cs
	  MessageFaultBodyWriter.cs IReplyChannel.cs
	  IBindingCapabilities.cs AddressHeader.cs IInputChannel.cs
	  IMessageProperty.cs IOutputChannel.cs NetPeerTcpBinding.cs
	  IRequestContext.cs IInputSessionShutdown.cs
	  SecurityBindingElement.cs PeerTransportBindingElement.cs
	  IDuplexSession.cs IChannelInitializer.cs
	  IProxyMessageInspector.cs IChannelListener.cs NetTcpBinding.cs
	  AddressingVersion.cs FaultException.cs
	  IRequestChannel.cs MtomMessageEncodingBindingElement.cs
	  TransportBindingElement.cs BinaryMessageEncodingBindingElement.cs
	  TextMessageEncodingBindingElement.cs IChannelFactory.cs Binding.cs
	  ITransportBindingElement.cs IChannelManager.cs MessageFault.cs
	  MessageHeaders.cs IStubMessageInspector.cs UnderstoodHeaders.cs
	  BindingParameterCollection.cs IInstanceProvider.cs
	  WSDualHttpBinding.cs ISession.cs IErrorHandler.cs
	  MessageEncodingBindingElement.cs HttpTransportBindingElement.cs
	  IDuplexChannel.cs CustomBinding.cs IOutputSessionChannel.cs
	  MessageContractAttribute.cs SymmetricSecurityBindingElement.cs :
	  moved from System.ServiceModel due to the API changes.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs ChannelListenerBase.cs HttpChannelFactory.cs
	  HttpChannelListener.cs HttpRequestChannel.cs
	  LayeredChannelListener.cs PeerMessagePropagationFilter.cs
	  PeerNode.cs ReplyChannelBase.cs :
	  Feb. CTP API changes - chapter 1.

2006-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBase.cs : OnOpen() and OnClosed() do nothing.
	* ReplyChannelBase.cs : now it is based on ChannelBase.
	* ChannelListenerBase_1.cs : use DefaultCommunicationTimeouts.Instance
	  and check null argument in .ctor().
	* HttpReplyChannel.cs : several changes.
	  Non-async members are mostly implemented.
	* HttpChannelListener.cs : no need to receive 
	  IDefaultCommunicationTimeouts.
	* HttpRequestChannel.cs : maxSizeOfHeaders is used in MessageHeaders
	  to allocate buffer array and int.MaxValue causes OutOfMemory.

2006-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientFramingDecoderState.cs : added missing enum.
	* HttpRequestMessageProperty.cs HttpResponseMessageProperty.cs :
	  added missing bits.
	* ChannelBase.cs, LayeredChannelListener.cs : tiny API fixes.

2006-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelListener.cs : Added GetChannels() and OnClose().
	  AcceptChannel() has some code now but it needs more love.

2006-02-14  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : Close() does not call Begin/EndClose().
	* ChannelManagerBase.cs : implemented AbortChannel and CloseChannel.
	* ChannelListenerBase.cs : implemented OnAbort and OnClose.

2006-02-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : close the streams.
	* HttpListener.cs
	  HttpChannelListener.cs : renamed from former to latter.

2006-02-09  Atsushi Enomoto  <atsushi@ximian.com>

	* ReplyChannelBase.cs : new file for IReplyChannel implementations.
	* HttpReplyChannel.cs : new file for HTTP IReplyChannel.
	* HttpListenerFactory.cs : removed obsolete file.
	* HttpListener.cs : hacky WaitForChannel and AcceptChannel.
	* ChannelListenerBase_1.cs : implemented virtual stuff.
	* CommunicationObject.cs : Open() should not call BeginOpen() and
	  EndOpen(). Instead, invoke events individually.
	* ChannelListenerBase.cs : its Open() is WaitForChannel().

2006-02-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : call Flush() after serializing message
	  into HTTP stream.

2006-02-08  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : implemented pretty hacky Request().

2006-02-02  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : Manager is HttpChannelFactory.

2006-02-01  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : removed some NotImplementedException for
	  further internal implementation.

2006-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestChannel.cs : new file. mostly not implemented.
	* HttpChannelFactory.cs : Implemented CanCreateChannel().
	  Partly implemented CreateChannel().

2006-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs : (.ctor())
	  Don't take ChannelBuildContext.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* StreamSecurityUpgradeInitiator.cs PeerMessageOrigination.cs
	  ChannelBase.cs StreamSecurityUpgradeAcceptor.cs
	  PeerMessagePropagation.cs : updated to Nov. CTP.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelListenerBase.cs, ChannelManagerBase.cs,
	  ChannelListenerBase_1.cs, LayeredChannelListener.cs,
	  StreamSecurityUpgradeAcceptor.cs,
	  StreamSecurityUpgradeInitiator.cs :
	  Updated to Nov. CTP API.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	Now we can rename ListenerFactoryBase.cs to ChannelListenerBase.cs.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	renamed ChannelListenerBase.cs to ChannelListenerBase_1.cs.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBase.cs : tiny filename fix.
	* ChannelListenerBase.cs : added more .ctor()s.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerFactory.cs LayeredChannelListener.cs HttpListener.cs
	  ListenerFactoryBase.cs ChannelListenerBase.cs :
	  updated IListener related stuff to Nov. CTP.
	  file renaming will come soon.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ListenerBase.cs, ChannelListenerBase.cs :
	  moved from former to latter.
	* LayeredListenerFactory.cs, LayeredChannelListener.cs :
	  moved from former to latter.

2005-11-20  Atsushi Enomoto  <atsushi@ximian.com>

	* SessionFaultedException.cs : removed in Nov. CTP

2005-11-20  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : updated to Nov. CTP.
	* SessionFaultedException.cs : removed (in Nov. CTP)

2005-11-03  Atsushi Enomoto  <atsushi@ximian.com>

	* TextMessageEncoder.cs : kinda implemented (untested; Message is not
	  working).

2005-11-03  Atsushi Enomoto  <atsushi@ximian.com>

	* MtomMessageEncoder.cs, BinaryMessageEncoderFactory.cs,
	  TextMessageEncoderFactory.cs, BinaryMessageEncoder.cs,
	  TextMessageEncoder.cs, MtomMessageEncoderFactory.cs : new files.
	* MessageEncoder.cs : largely implemented.

2005-11-02  Atsushi Enomoto  <atsushi@ximian.com>

	* IRequestReplyCorrelator.cs : new file.

2005-11-02  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : OnClose() and OnError() are not virtual.
	* DirectionalAction.cs : implemented IComparable<DirectionalAction>.
	* MessageEncoder.cs : added misssing ToString().

2005-11-02  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBehaviorCollection.cs : moved to sys.sm.

2005-10-28  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpListenerFactory.cs, HttpListener.cs : new files.
	* ListenerFactoryBase.cs, ChannelManagerBase.cs,
	  CommunicationObject.cs, ChannelFactoryBase.cs,
	  StreamUpgradeProvider.cs, ChannelBase.cs : timeouts are now
	  protected internal.
	* CommunicationObject.cs : Aborted is bool. Added InternalClose()
	* ListenerFactoryBase.cs : kinda implemented GetListeners().

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ListenerFactoryBase.cs : some implementation.

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : more state fixes.

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : some state machine fixes.

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerNode.cs, ChannelManagerBase.cs :
	  several API fixes detected by improved corcompare.

2005-10-25  Atsushi Enomoto  <atsushi@ximian.com>

	* LayeredListenerFactory.cs : added missing generic class constraint.

2005-10-25  Atsushi Enomoto  <atsushi@ximian.com>

	* ListenerFactoryBase.cs,
	  ListenerBase.cs : class constraints were missing for generic args.

2005-10-24  Atsushi Enomoto  <atsushi@ximian.com>

	* StreamUpgradeInitiator.cs : tiny API fix.

2005-10-23  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerMessagePropagationFilter.cs : tiny build fix.

2005-10-23  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpRequestMessageProperty.cs, HttpResponseMessageProperty.cs :
	  added Name. fixed StatusCode type.
	* StreamSecurityUpgradeInitiator.cs, StreamUpgradeAcceptor.cs,
	  PeerNode.cs, StreamSecurityUpgradeAcceptor.cs,
	  StreamUpgradeProvider.cs, StreamUpgradeInitiator.cs,
	  DirectionalAction.cs, HostedTransportConfiguration.cs,
	  StreamSecurityUpgradeProvider.cs, SessionFaultedException.cs,
	  PeerMessagePropagationFilter.cs : added missing files.
	* Dummy.cs : removed. MSMQ stuff can be added later.

2005-10-21  Atsushi Enomoto  <atsushi@ximian.com>

	* DeliveryStatus.cs, DeliveryFailure.cs,
	  HttpRequestMessageProperty.cs, PeerMessageOrigination.cs,
	  PeerMessagePropagation.cs, HttpResponseMessageProperty.cs :
	  new files.
	* Dummy.cs : removed above.

2005-10-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelFactoryBase.cs : tiny .ctor() delegation fix.

2005-10-09  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageEncoderFactory.cs, LayeredListenerFactory.cs,
	  MessageEncoder.cs, BufferManager.cs : new files.
	* Dummy.cs : removed above.

2005-10-09  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBase.cs, ChannelBehaviorCollection.cs : new channel files.
	* Dummy.cs : removed above.
	* CommunicationObject.cs, ListenerFactoryBase.cs : added missing bits.

2005-10-09  Atsushi Enomoto  <atsushi@ximian.com>

	* HttpChannelFactory.cs : new file.

2005-10-08  Atsushi Enomoto  <atsushi@ximian.com>

	* IReplyChannel.cs, IRequestContext.cs, IRequestChannel.cs:
	  moved to ../System.ServiceModel (correct location).
	* ChannelFactoryBase.cs, LayeredChannelFactory.cs, TransferMode.cs:
	  new files for channels.
	* Dummy.cs : reflected above changes.
	* ChannelManagerBase.cs : added a bit of code and todos.

2005-10-04  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelManagerBase.cs, ListenerBase.cs, ListenerFactoryBase.cs :
	  added listener support files.
	* Dummy.cs : removed above.

2005-10-03  Atsushi Enomoto  <atsushi@ximian.com>

	* IReplyChannel.cs, IRequestContext.cs, IRequestChannel.cs :
	  added request/reply channel interfaces.
	* Dummy.cs : removed above.
	* CommunicationObject.cs : FIXME comments.

2005-10-03  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : implemented some members.

2005-09-29  Atsushi Enomoto  <atsushi@ximian.com>

	* CommunicationObject.cs : some signature fixes.

